#include <atmel/at89x51.h>
#include <stdio.h>
#include <intrins.h>

  

 void serial_init(void) 
 {
    SCON  = 0x50;		        /* SCON: mode 1, 8-bit UART, enable rcvr      */
    TMOD |= 0x20;               /* TMOD: timer 1, mode 2, 8-bit reload        */
    TH1   = 0xF3;               /* TH1:  reload value for 2400 baud @ 12MHz   */
    TR1   = 1;                  /* TR1:  timer 1 run                          */
    TI    = 1;                  /* TI:   set TI to send first char of UART    */
 }

//-----------------------------------------------------------------------------------------
 void robot_init(void)
 {
  serial_init();
  printf("\n\nSERGEJ ROBOT interface created by DJ MaBo & Wray (c)2004\n\n");

/*  printf("\n  ******* Riadiace prikazy *******");
  printf("\n  \"s\" restart systemu");
  printf("\n  \"u\" vypnutie motorov");
  printf("\n  \"f\" krok dopredu (F odozva)");
  printf("\n  \"b\" krok dozadu (B odozva)");
  printf("\n  \"l\" otocenie 90 stupnov dolava");
  printf("\n  \"r\" otocenie 90 stupnov doprava"); 
  printf("\n  \"t\" otocenie 180 stupnov"); 
  printf("\n  \"g\" L odozva");
  printf("\n  \"h\" R odozva");
  printf("\n  \"i\" FL odozva");
  printf("\n  \"j\" FR odozva");
  printf("\n  \"k\" LF odozva");
  printf("\n  \"m\" RF odozva");
  printf("\n  \"n\" LB odozva");
  printf("\n  \"o\" RB odozva");
  printf("\n  \"p\" BL odozva");
  printf("\n  \"q\" BR odozva");  
  printf("\n  \"+\" rychlost +50");
  printf("\n  \"-\" rychlost -50");
  printf("\n  Default rychlost je 800");
  printf("\n\n Popis odoziev najdete v helpe alebo kontaktujte autora djmabo@post.cz\n\n");
//  printf("\n  ""c"" pocitadlo krokov");
*/

 }
//-------------------------------------------------------------------------------------------
void wait (unsigned int time)
 {
  unsigned int j;
  for (j=0;j<time;j++)
	_nop_ ();                     
 }
//-------------------------------------------------------------------------------------------
void flash_led(void)
 {
  P3_7 ^=  1;
  P3_6 ^=  1;
 }
//-------------------------------------------------------------------------------------------
void forward (unsigned int steps, unsigned int speed)
 {				
  unsigned int j;
  for (j=0;j<steps;j++)
   {
    P0 = 0x81;	 wait(speed);
	P0 = 0x42;	 wait(speed);				
	P0 = 0x24;	 wait(speed);
	P0 = 0x18;	 wait(speed);	
   }
 }
//--------------------------------------------------------------------------------------------
void backward (unsigned int steps, unsigned int speed)
 {				
  unsigned int j;
  for (j=0;j<steps;j++)
   {
	P0 = 0x18;	 wait(speed);
	P0 = 0x24;	 wait(speed);				
	P0 = 0x42;	 wait(speed);
	P0 = 0x81;	 wait(speed);	
   }
 }
//--------------------------------------------------------------------------------------------
void left (unsigned int steps, unsigned int speed)
 {				
  unsigned int j;
  for (j=0;j<steps;j++)
   {
	P0 = 0x11;	 wait(speed);
	P0 = 0x22;	 wait(speed);				
	P0 = 0x44;	 wait(speed);
	P0 = 0x88;	 wait(speed);	
   }
 }
//--------------------------------------------------------------------------------------------
void right (unsigned int steps, unsigned int speed)
 {				
  unsigned int j;
  for (j=0;j<steps;j++)
   {
    P0 = 0x88;	 wait(speed);
	P0 = 0x44;	 wait(speed);				
	P0 = 0x22;	 wait(speed);
	P0 = 0x11;	 wait(speed);	
   }
 }
//--------------------------------------------------------------------------------------------
/*void error(int er)
 {
  switch (er)
   {
    case '0' : printf("%c",230); break; // posielam signal senzor P1.0 bol zopnuty
    case '1' : printf("%c",231); break; // posielam signal senzor P1.1 bol zopnuty
    case '2' : printf("%c",232); break; // posielam signal senzor P1.2 bol zopnuty
	case '3' : printf("%c",233); break; // posielam signal senzor P1.3 bol zopnuty
	case '4' : printf("%c",234); break; // posielam signal senzor P1.4 bol zopnuty
	case '5' : printf("%c",235); break; // posielam signal senzor P1.5 bol zopnuty
    
   }
 }*/
//--------------------------------------------------------------------------------------------
unsigned int f (unsigned int rychlost)
 {
  unsigned int i, pom_krok = 0;
  flash_led();
   
  P0 = 0x81;  wait(rychlost+400);
  P0 = 0x42;  wait(rychlost+300);	
  P0 = 0x24;  wait(rychlost+200);
  P0 = 0x18;  wait(rychlost+100);

  if((P1_0 == 0) || (P1_1 == 0) || (P1_2 == 0) )
   {
	if (P1_0 == 0) printf("%c",230);
     else
      {
       if (P1_1 == 0) printf("%c",231);
	   if (P1_2 == 0) printf("%c",232);
      } 
	backward(pom_krok,rychlost);
    return(1);
   }
  pom_krok ++;		// 1 krok spomaleneho rozbehu presliel v pohode

  for (i=1;i<=46;i++)
   {
    forward(1,rychlost);
	pom_krok ++;
	if((P1_0 == 0) || (P1_1 == 0) || (P1_2 == 0) )
	 {
	  if (P1_0 == 0) printf("%c",230);
     else
      {
       if (P1_1 == 0) printf("%c",231);
	   if (P1_2 == 0) printf("%c",232);
      }
	  backward(pom_krok,rychlost);
	  return(1);
	 }

   } // 48 krokov preslo v pohode 	
		
		 
   P0 = 0x81;	 wait(rychlost+100);
   P0 = 0x42;    wait(rychlost+200);	
   P0 = 0x24;	 wait(rychlost+300);
   P0 = 0x18;    wait(rychlost+400);
					
   if((P1_0 == 0) || (P1_1 == 0) || (P1_2 == 0) )
    {
     if (P1_0 == 0) printf("%c",230);
     else
      {
       if (P1_1 == 0) printf("%c",231);
	   if (P1_2 == 0) printf("%c",232);
      }
	 backward(pom_krok,rychlost);
	 return(1);
	}						

	printf("%c",238);	//krok dopredu OK
    flash_led();
	return(0);

 }
//--------------------------------------------------------------------------------------------
unsigned int b (unsigned int rychlost)
 {
  unsigned int i, pom_krok = 0;
  flash_led();

  P0 = 0x18;	 wait(rychlost+400);
  P0 = 0x24;	 wait(rychlost+300);				
  P0 = 0x42;	 wait(rychlost+200);
  P0 = 0x81;	 wait(rychlost+100);

  if((P1_3 == 0) || (P1_4 == 0) || (P1_5 == 0) )
   {
	if (P1_3 == 0) printf("%c",233);
     else
      {
       if (P1_4 == 0) printf("%c",234);
	   if (P1_5 == 0) printf("%c",235);
      }
	forward(pom_krok,rychlost);
	return(1);
   }
  pom_krok ++;		// 1 krok spomaleneho rozbehu presiel v pohode

  for (i=1;i<=46;i++)
   {
    backward(1,rychlost);
    pom_krok ++;
    if((P1_3 == 0) || (P1_4 == 0) || (P1_5 == 0) )
     {
     if (P1_3 == 0) printf("%c",233);
     else
      {
       if (P1_4 == 0) printf("%c",234);
	   if (P1_5 == 0) printf("%c",235);
      }
	  forward(pom_krok,rychlost);
	  return(1);
	 }

   } // 48 krokov preslo v pohode 	
		
  P0 = 0x18;	 wait(rychlost+100);
  P0 = 0x24;	 wait(rychlost+200);				
  P0 = 0x42;	 wait(rychlost+300);
  P0 = 0x81;	 wait(rychlost+400);

  if((P1_3 == 0) || (P1_4 == 0) || (P1_5 == 0) )
   {
	if (P1_3 == 0) printf("%c",233);
     else
      {
       if (P1_4 == 0) printf("%c",234);
	   if (P1_5 == 0) printf("%c",235);
      }
	forward(pom_krok,rychlost);
	return(1);
   }						

  printf("%c",240);	//krok dozadu OK
  flash_led();
  return(0);
 }
//--------------------------------------------------------------------------------------------
void l(unsigned int rychlost)	
 {
  flash_led();
  P0 = 0x11;	 wait(rychlost+800);
  P0 = 0x22;	 wait(rychlost+700);				
  P0 = 0x44;	 wait(rychlost+600);
  P0 = 0x88;	 wait(rychlost+500);	        

  P0 = 0x11;	 wait(rychlost+400);
  P0 = 0x22;	 wait(rychlost+300);				
  P0 = 0x44;	 wait(rychlost+200);
  P0 = 0x88;	 wait(rychlost+100);	        

  left(20,rychlost);

  P0 = 0x11;	 wait(rychlost+100);
  P0 = 0x22;	 wait(rychlost+200);				
  P0 = 0x44;	 wait(rychlost+300);
  P0 = 0x88;	 wait(rychlost+400);	        

  P0 = 0x11;	 wait(rychlost+500);
  P0 = 0x22;	 wait(rychlost+600);				
  P0 = 0x44;	 wait(rychlost+700);
  P0 = 0x88;	 wait(rychlost+800);	        
			
  printf ("%c",242);
  flash_led();
 }
//--------------------------------------------------------------------------------------------
void r(unsigned int rychlost)
 {
  flash_led();
  P0 = 0x88;	 wait(rychlost+800);
  P0 = 0x44;	 wait(rychlost+700);				
  P0 = 0x22;	 wait(rychlost+600);
  P0 = 0x11;	 wait(rychlost+500);	        

  P0 = 0x88;	 wait(rychlost+400);
  P0 = 0x44;	 wait(rychlost+300);				
  P0 = 0x22;	 wait(rychlost+200);
  P0 = 0x11;	 wait(rychlost+100);	        

  right(20,rychlost);

  P0 = 0x88;	 wait(rychlost+100);
  P0 = 0x44;	 wait(rychlost+200);				
  P0 = 0x22;	 wait(rychlost+300);
  P0 = 0x11;	 wait(rychlost+400);	        

  P0 = 0x88;	 wait(rychlost+500);
  P0 = 0x44;	 wait(rychlost+600);				
  P0 = 0x22;	 wait(rychlost+700);
  P0 = 0x11;	 wait(rychlost+800);	        
		
  printf ("%c",244);
  flash_led();
 }
//--------------------------------------------------------------------------------------------

void main() 
  {
   char znak;
   unsigned int a=1, rychlost=800; 

   robot_init();
   P3_6 = 0;
 
   while (a==1) 
    {   //a- sme v switch
      von:   znak = getchar();
             P0 = 0;
             P3_6 = 0;
			 P3_7 = 1;			

      switch (znak) 
	   {
         case 'u': //release robot
	      P0 = 0;
	     break;
//-------------------------------------------------------------------------------------------------------------
	     case 'l':  //idem dolava
		  l(rychlost); //funkcia left(24)
		 break;
//--------------------------------------------------------------------------------------------------------------
	     case 'r': //idem doprava
		  r(rychlost); //funkcia right(24)
		 break;

//---------------------------------------------------------------------------------------------------------------	  
/*	  case 'c': printf("\nPocitam kroky\n");
				pom_krok = 0;
				while (P1_0 == 1)
 					{ 
                     forward(1,rychlost);
					 pom_krok ++;
					}
				
				printf("\nPresiel %d krokov\n",pom_krok);
				break;

*/
//---------------------------------------------------------------------------------------------------------------
	     case 's': 
	  	  a=0;
		 break;

         case '-': 
		  rychlost += 50;
	  	  if(rychlost >= 1500)
		   rychlost = 1500;
		 break;

	     case '+': 
		  rychlost -= 50;
	  	  if(rychlost <= 400)
		   rychlost = 400;
		 break;
	  
//--------------------------------------------------------------------------------------------------------------
	     case 'f':                                      // F odozva
		  if (f(rychlost) == 1)
		   goto von; //funkcia fowrard 24
 		 break;

//----------------------------------------------------------------------------------------------------------
		 case 'b':                                   // B odozva
		  if (b(rychlost) == 1)
		   goto von; //funkcia backward 24
		 break;
			
//----------------------------------------------------------------------------------------------------------				
         case 'h' :                                    // R odozva
          r(rychlost); 
		  if (f(rychlost) == 1)
		   goto von;
		 break;

//----------------------------------------------------------------------------------------------------------
    	 case 'g' :                                    // L odozva
          l(rychlost);
		  if (f(rychlost) == 1)
		   goto von;
		 break;

//----------------------------------------------------------------------------------------------------------
         case 'i' :									// FL odozva
	      if (f(rychlost) == 1)
		   goto von;
          l(rychlost);
		  if (f(rychlost) == 1)
		   goto von; 
         break;

//----------------------------------------------------------------------------------------------------------
         case 'j' :									//FR odozva
          if (f(rychlost) == 1)
		   goto von;
          r(rychlost);
		  if (f(rychlost) == 1)
		   goto von; 
          break;             

//----------------------------------------------------------------------------------------------------------
    	 case 'k' :									// LF odozva
	      l(rychlost);
		  if (f(rychlost) == 1)
		   goto von; 
          r(rychlost) ;
          if (f(rychlost) == 1)  
		   goto von;
		  break;

//----------------------------------------------------------------------------------------------------------
		  case 'm' :									// RF odozva
	       r(rychlost);
		   if (f(rychlost) == 1)
		    goto von; 
           l(rychlost) ;
           if (f(rychlost) == 1)  
		    goto von;
		   break;

//----------------------------------------------------------------------------------------------------------
	     case 'n' :									// LB odozva
		  l(rychlost) ;
          if (f(rychlost) == 1)  
		   goto von;
		  l(rychlost) ;
          if (f(rychlost) == 1)  
		   goto von;
		  break;

//----------------------------------------------------------------------------------------------------------
	     case 'o' :									// RB odozva
	      r(rychlost) ;
          if (f(rychlost) == 1)  
		   goto von;
		  r(rychlost) ;
          if (f(rychlost) == 1)  
		   goto von;
		  break;

//----------------------------------------------------------------------------------------------------------
		  case 'p' :								// BL odozva
		   if (b(rychlost) == 1)  
		    goto von;
		   l(rychlost) ;
		   if (f(rychlost) == 1)  
		    goto von;
		   break;

//----------------------------------------------------------------------------------------------------------
	     case 'q' :									// BR odozva
	      if (b(rychlost) == 1)  
		   goto von;
		  r(rychlost) ;
		  if (f(rychlost) == 1)  
		   goto von;
		 break;
//----------------------------------------------------------------------------------------------------------
	     case 't' :									// otocenie 180 stupnov
	       r(rychlost) ;
 		   r(rychlost) ;
		 break;
//----------------------------------------------------------------------------------------------------------

       } // koniec switch
    } // koniec while

  } // koniec main
