//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit7.h"
#include "math.h"
#include <stdio.h>



#define ObstacleLimit 40                // Top Obstacle Limit
#define XStartPos 1                     // Default Robot X Starting position
#define YStartPos 1                     // Default Robot Y Starting position

/* Personal Notes
i - counter variable do NOT use as global
X,Y - temp pos variable do NOT use as global


*/

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CPort"
#pragma link "CPortCtl"
#pragma resource "*.dfm"
TForm1 *Form1;
int ArrayModel[13][13];                                     //corrsesponding image is "ArrayModelImage"
int Array[13][13];                                          //corrsesponding image is "ArrayImage"
int TempXDestination,TempYDestination,XDestination,YDestination,XPos,YPos;
int orientation;                                            // 1=N 2=E 3=S 4=W
int NextStepCode;                                           // see NextStepCodeTable.txt

int Genotype[32];
int GenotypeOccurence[32];                                  // Loguje kolkokrat sa vyskytla ktora situacia

int StepCounter=0;
int StepCounterDetector=0;
int StepCounterAlternate=0;                                     // Hodnotenie situacii potrebuje svoj
int TargetNotReached=0;

int ModifyAmmount=0;

int RecoveryMethod=1;
int PrimaryMethod=1;
int MetricsMethod=2;

float DistanceLog[999];
int PositionLog[999];
int SituationLog[999];

bool BlindLoop=false;                                       // EndlessLoopDetection;
bool NotLogged=true;
bool UsingTemporaryTarget=false;                              // urcuje ci sa prave blizim k docasnemu cielu alebo k tomu realnemu

int Step = 0;

TListItem *polozka;



/////////////////////////////////////////////////////////////////
void TForm1::LoadGenotype(void){                       //staticky
        Genotype[0]=1;          //changed from 3
        Genotype[1]=5;
        Genotype[2]=1;
        Genotype[3]=7;
        Genotype[4]=7;         //changed from 8
        Genotype[5]=3;
        Genotype[6]=7;
        Genotype[7]=7;
        Genotype[8]=1;
        Genotype[9]=6;
        Genotype[10]=3;
        Genotype[11]=1;
        Genotype[12]=8;
        Genotype[13]=3;
        Genotype[14]=2;
        Genotype[15]=3;
        Genotype[16]=1;
        Genotype[17]=6;
        Genotype[18]=5;
        Genotype[19]=1;
        Genotype[20]=2;
        Genotype[21]=4;
        Genotype[22]=2;
        Genotype[23]=11;
        Genotype[24]=1;
        Genotype[25]=1;
        Genotype[26]=1;
        Genotype[27]=1;
        Genotype[28]=8;
        Genotype[29]=11;
        Genotype[30]=2;
        Genotype[31]=12;

        for (int i=0;i<32;i++)GenotypeOccurence[i]=0;
        ShowGenotype();

                            }
/////////////////////////////////////////////////////////////////
int TForm1::RotateGenotype(int position){
        if (position==0 && Genotype[position]==1)return(2);
        if (position==0 && Genotype[position]==2)return(3);
        if (position==0 && Genotype[position]==3)return(5);
        if (position==0 && Genotype[position]==5)return(6);
        if (position==0 && Genotype[position]==6)return(7);
        if (position==0 && Genotype[position]==7)return(8);
        if (position==0 && Genotype[position]==8)return(1);

        if (position==1 && Genotype[position]==1)return(7);
        if (position==1 && Genotype[position]==2)return(1);
        if (position==1 && Genotype[position]==5)return(2);
        if (position==1 && Genotype[position]==6)return(5);
        if (position==1 && Genotype[position]==7)return(6);

        if (position==2 && Genotype[position]==1)return(7);
        if (position==2 && Genotype[position]==2)return(1);
        if (position==2 && Genotype[position]==3)return(2);
        if (position==2 && Genotype[position]==5)return(3);
        if (position==2 && Genotype[position]==7)return(5);

        if (position==3 && Genotype[position]==1)return(7);
        if (position==3 && Genotype[position]==2)return(1);
        if (position==3 && Genotype[position]==5)return(2);
        if (position==3 && Genotype[position]==7)return(5);

        if (position==4 && Genotype[position]==2)return(8);
        if (position==4 && Genotype[position]==3)return(2);
        if (position==4 && Genotype[position]==7)return(3);
        if (position==4 && Genotype[position]==8)return(7);

        if (position==5 && Genotype[position]==2)return(7);
        if (position==5 && Genotype[position]==7)return(2);

        if (position==6 && Genotype[position]==2)return(7);
        if (position==6 && Genotype[position]==3)return(2);
        if (position==6 && Genotype[position]==7)return(3);

        if (position==7 && Genotype[position]==2)return(7);
        if (position==7 && Genotype[position]==7)return(2);

        if (position==8 && Genotype[position]==1)return(8);
        if (position==8 && Genotype[position]==2)return(1);
        if (position==8 && Genotype[position]==3)return(2);
        if (position==8 && Genotype[position]==6)return(3);
        if (position==8 && Genotype[position]==8)return(6);

        if (position==9 && Genotype[position]==1)return(6);
        if (position==9 && Genotype[position]==2)return(1);
        if (position==9 && Genotype[position]==6)return(2);

        if (position==10 && Genotype[position]==1)return(3);
        if (position==10 && Genotype[position]==2)return(1);
        if (position==10 && Genotype[position]==3)return(2);

        if (position==11 && Genotype[position]==1)return(2);
        if (position==11 && Genotype[position]==2)return(1);

        if (position==12 && Genotype[position]==2)return(8);
        if (position==12 && Genotype[position]==8)return(2);

        if (position==13)return(2);

        if (position==14 && Genotype[position]==2)return(3);
        if (position==14 && Genotype[position]==3)return(2);

        if (position==15)return(2);

        if (position==16 && Genotype[position]==1)return(6);
        if (position==16 && Genotype[position]==3)return(1);
        if (position==16 && Genotype[position]==5)return(3);
        if (position==16 && Genotype[position]==6)return(5);

        if (position==17 && Genotype[position]==1)return(5);
        if (position==17 && Genotype[position]==6)return(1);
        if (position==17 && Genotype[position]==5)return(6);

        if (position==18 && Genotype[position]==1)return(5);
        if (position==18 && Genotype[position]==3)return(1);
        if (position==18 && Genotype[position]==5)return(3);

        if (position==19 && Genotype[position]==1)return(5);
        if (position==19 && Genotype[position]==5)return(1);

        if (position==20 && Genotype[position]==3)return(8);
        if (position==20 && Genotype[position]==8)return(3);

        if (position==21 && Genotype[position]==4)return(12);
        if (position==21 && Genotype[position]==11)return(4);
        if (position==21 && Genotype[position]==12)return(11);

        if (position==22)return(3);

        if (position==23 && Genotype[position]==4)return(12);
        if (position==23 && Genotype[position]==11)return(4);
        if (position==23 && Genotype[position]==12)return(11);

        if (position==24 && Genotype[position]==1)return(8);
        if (position==24 && Genotype[position]==3)return(1);
        if (position==24 && Genotype[position]==6)return(3);
        if (position==24 && Genotype[position]==8)return(6);

        if (position==25 && Genotype[position]==1)return(6);
        if (position==25 && Genotype[position]==6)return(1);

        if (position==26 && Genotype[position]==1)return(3);
        if (position==26 && Genotype[position]==3)return(1);

        if (position==27)return(1);

        if (position==28 && Genotype[position]==3)return(8);
        if (position==28 && Genotype[position]==8)return(3);

        if (position==29 && Genotype[position]==4)return(12);
        if (position==29 && Genotype[position]==11)return(4);
        if (position==29 && Genotype[position]==12)return(11);

        if (position==30)return(3);

        if (position==31 && Genotype[position]==4)return(12);
        if (position==31 && Genotype[position]==11)return(4);
        if (position==31 && Genotype[position]==12)return(11);

   //     return(99);        // v pripade nejasnosti radsej vymyslim novy krok...
                             // toto je kvoli tomu ze nikdy si nemozem byt isty ze "mi bol dodany" standardny genotyp
                             // ...napriklad pri nahodnom generovani
          return(random(12)+1);

}
/////////////////////////////////////////////////////////////////
int TForm1::GenerateGen(int position){
        return(random(12)+1);}
/////////////////////////////////////////////////////////////////
void TForm1::SetRecoveryMethod(){
     if (Form1->RecoveryMethod0->Checked)RecoveryMethod=0;
     if (Form1->RecoveryMethod1->Checked)RecoveryMethod=1;
     if (Form1->RecoveryMethod2->Checked)RecoveryMethod=2;
     if (Form1->RecoveryMethod3->Checked)RecoveryMethod=3;
                        }
/////////////////////////////////////////////////////////////////
void TForm1::SetMetricsMethod(void)
{
        if (Form1->Metrics1->Checked)MetricsMethod=1;
        if (Form1->Metrics2->Checked)MetricsMethod=2;
        if (Form1->Metrics3->Checked)MetricsMethod=3;
        if (Form1->Metrics4->Checked)MetricsMethod=4;        
}
/////////////////////////////////////////////////////////////////
void TForm1::SetPrimaryMethod(void)
{
     if (Form1->PrimaryMethod0->Checked)PrimaryMethod=0;
     if (Form1->PrimaryMethod1->Checked)PrimaryMethod=1;
     if (Form1->PrimaryMethod2->Checked)PrimaryMethod=2;
     if (Form1->PrimaryMethod3->Checked)PrimaryMethod=3;
}
/////////////////////////////////////////////////////////////////
String TForm1::DecodeGen(int gen){
if (gen==1)return("F");
if (gen==2)return("R");
if (gen==3)return("L");
if (gen==4)return("B");
if (gen==5)return("FL");
if (gen==6)return("FR");
if (gen==7)return("LF");
if (gen==8)return("RF");
if (gen==9)return("LB");
if (gen==10)return("RB");
if (gen==11)return("BL");
if (gen==12)return("BR");
return ("!");
}
/////////////////////////////////////////////////////////////////

void TForm1::ShowGenotype(){
         Form1->GenotypeGrid->Cells[0][0]="Sit";
         Form1->GenotypeGrid->Cells[0][1]="Kd";
         Form1->GenotypeGrid->Cells[0][2]="Odz";
         Form1->GenotypeGrid->Cells[0][3]="Vs";


         for (int i=0;i<32;i++){
            Form1->GenotypeGrid->Cells[i+1][0]=i;
            Form1->GenotypeGrid->Cells[i+1][1]=Genotype[i];
            Form1->GenotypeGrid->Cells[i+1][2]=DecodeGen(Genotype[i]);
            Form1->GenotypeGrid->Cells[i+1][3]=GenotypeOccurence[i];
}

                    }
/////////////////////////////////////////////////////////////////
double TForm1::Round2(float argument){
      double temp=ceil(argument*100);temp/=100;
      return (temp);
                            }
/////////////////////////////////////////////////////////////////
void TForm1::ResetProgressGraph(void){
//     Form1->ProgressGraphImage->Canvas->Pen->Color = clWhite;

     Form1->ProgressGraphImage->Canvas->Rectangle(0,0,Form1->ProgressGraphImage->Width,Form1->ProgressGraphImage->Height);
     Form1->ProgressGraphImage->Canvas->Pen->Color = clBlack;

     Form1->ProgressGraphImage->Canvas->MoveTo(5,0);
     Form1->ProgressGraphImage->Canvas->LineTo(5,Form1->ProgressGraphImage->Height);
     Form1->ProgressGraphImage->Canvas->MoveTo(0,Form1->ProgressGraphImage->Height-5);
     Form1->ProgressGraphImage->Canvas->LineTo(Form1->ProgressGraphImage->Width,Form1->ProgressGraphImage->Height-5);
     Form1->ProgressGraphImage->Canvas->MoveTo(5,0);

                          }
/////////////////////////////////////////////////////////////////
void TForm1::GetDestinationCoordinates(){
     XDestination=StrToInt(Form1->XDestinationEdit->Text);
     YDestination=StrToInt(Form1->YDestinationEdit->Text);
                                }
/////////////////////////////////////////////////////////////////
void TForm1::ShowModelObstacle(int x,int y){
        Graphics::TBitmap* ObstacleBitmap = new Graphics::TBitmap();
        ObstacleBitmap->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/obstacle.bmp");
        Form1->ArrayModelImage->Canvas->Draw( (5+(x-1)*32),(362-5-y*32) ,ObstacleBitmap);
                delete ObstacleBitmap;
                                   }
/////////////////////////////////////////////////////////////////
void TForm1::ShowObstacle(int x,int y){
        Graphics::TBitmap* ObstacleBitmap = new Graphics::TBitmap();
        ObstacleBitmap->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/obstacle.bmp");
        Form1->ArrayImage->Canvas->Draw( (5+(x-1)*32),(362-5-y*32) ,ObstacleBitmap);
                delete ObstacleBitmap;
                                   }
/////////////////////////////////////////////////////////////////
void TForm1::ShowUseless(int x, int y)
{
        Graphics::TBitmap* UselessBitmap = new Graphics::TBitmap();
        UselessBitmap->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/useless.bmp");
        Form1->ArrayImage->Canvas->Draw( (5+(x-1)*32),(362-5-y*32) ,UselessBitmap);
                delete UselessBitmap;
}
/////////////////////////////////////////////////////////////////
void TForm1::ShowTemp(int x,int y){
        Graphics::TBitmap* TempBitmap = new Graphics::TBitmap();
        TempBitmap->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/temp.bmp");
        Form1->ArrayImage->Canvas->Draw( (5+(x-1)*32),(362-5-y*32) ,TempBitmap);
                delete TempBitmap;
                                  }
/////////////////////////////////////////////////////////////////
void TForm1::ShowFree(int x,int y){
        Graphics::TBitmap* FreeBitmap = new Graphics::TBitmap();
        FreeBitmap->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/free.bmp");
        Form1->ArrayImage->Canvas->Draw( (5+(x-1)*32),(362-5-y*32) ,FreeBitmap);
                delete FreeBitmap;
                                   }
/////////////////////////////////////////////////////////////////
int TForm1::FindZone(int Width, int Height)
{
// Form1->ListBox1->Items->Clear();
// Form1->ListBox1->Items->Add("Width je "+IntToStr(Width)+" Height je "+IntToStr(Height));



for (int i=0;i<(14-Width);i++){
 for (int j=0;j<(14-Height);j++){


            // Skontrolujem ci zona neobsahuje robota, ciel, prip. docasny ciel
            // Zona taktiez musi obsahovat aspon jedno prazne policko inak to nema zmysel
              bool ZoneIsValid=true;
              int FreeCells=0;
              for (int a=0;a<Width;a++){
               for (int b=0;b<Height;b++){
                 if (XPos==(i+a) && YPos==(j+b))ZoneIsValid=false;
                 if (XDestination==(i+a) && YDestination==(j+b))ZoneIsValid=false;
                 if (TempXDestination==(i+a) && TempYDestination==(j+b))ZoneIsValid=false;
                                          }
                                        }
                                        
              for (int a=1;a<Width-1;a++)
               for (int b=1;b<Height-1;b++)
                 if (Array[i+a][j+b]==0)FreeCells++;

              if (FreeCells==0)ZoneIsValid=false;


        if (ZoneIsValid){

// Form1->ListBox1->Items->Add("Nasiel som validnu zonu, bez robota a cielov, startovacia pozicia je "+IntToStr(i)+","+IntToStr(j));

            // Koniec kontroly ak je zona v poriadku tak ZoneIsValid je true
            // Skontrolujem ci hranice zony zodpovedaju predpokladom
              int BordersRank=0;
            // Najskor skontrolujem vodorovne hranice
              for (int a=1;a<=Width-2;a++){
                   if (Array[i+a][j]==1 || Array[i+a][j]>=2)BordersRank++;
                   if (Array[i+a][j+Height-1]==1 || Array[i+a][j+Height-1]>=2)BordersRank++;
                                          }

// Form1->ListBox1->Items->Add("Tato zona ma hranic vo vodorovnom smere: "+IntToStr(BordersRank));

            // Teraz zvisle hranice
              for (int b=1;b<=Height-2;b++){
                   if (Array[i][j+b]==1 || Array[i][j+b]>=2)BordersRank++;
                   if (Array[i+Width-1][j+b]==1 || Array[i+Width-1][j+b]>=2)BordersRank++;
                                           }

// Form1->ListBox1->Items->Add("Tato zona ma hranic spolu: "+IntToStr(BordersRank));

            // v BorderRank je kolko ma zona po okrajoch "vhodnych" pozicii
            // Ak je vsetko vporiadku vyplnim zonu
            if (BordersRank==(2*(Width+Height-4))){
// Form1->ListBox1->Items->Add("Validna zona, bez robota a cielov:  "+IntToStr(i)+","+IntToStr(j)+" mala Rank "+IntToStr(BordersRank)+" Plnim!");StopAutoTimer();
// Form1->ListBox1->Items->Add("Docasny ciel "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination)+" nelezal v tejto zone");
                     for (int a=1;a<Width;a++){
                      for (int b=1;b<Height;b++){
                        if (Array[i+a][j+b]==0)Array[i+a][j+b]=12;
                        // RefreshArray();
                                                }
                                              }
                        return(1);                      
                                                   }
                          }



                                 }
                                }
return(0);              //keby daco...
}
/////////////////////////////////////////////////////////////////
void TForm1::FindUselessFields(void)
{
int Rank;

for(int x=0;x<11;x++){
       for (int i=1;i<12;i++){
         for (int j=1;j<12;j++){
              Rank=0;
                   if (i==XPos && j==YPos){}
                    else{
                   if (Array[i+1][j]>1)Rank++;
                   if (Array[i][j+1]>1)Rank++;
                   if (Array[i-1][j]>1)Rank++;
                   if (Array[i][j-1]>1)Rank++;
                       if (Rank>2 && Array[i][j]!=2 && Array[i][j]!=12){Array[i][j]=12;ShowUseless(i,j);}
                       if (i==XDestination && j==YDestination){ShowDestination();}
                         }


                    if (i==XPos && j==YPos){}
                     else{
                     if (Array[i-1][j]>1 && Array[i][j+1]>1 && Array[i+1][j-1]==1 && Array[i][j]!=2 && Array[i][j]!=12){Array[i][j]=12;ShowUseless(i,j);}
                     if (Array[i-1][j]>1 && Array[i][j-1]>1 && Array[i+1][j+1]==1 && Array[i][j]!=2 && Array[i][j]!=12){Array[i][j]=12;ShowUseless(i,j);}
                     if (Array[i][j-1]>1 && Array[i+1][j]>1 && Array[i-1][j+1]==1 && Array[i][j]!=2 && Array[i][j]!=12){Array[i][j]=12;ShowUseless(i,j);}
                     if (Array[i+1][j]>1 && Array[i][j+1]>1 && Array[i-1][j-1]==1 && Array[i][j]!=2 && Array[i][j]!=12){Array[i][j]=12;ShowUseless(i,j);}
                       if (i==XDestination && j==YDestination){ShowDestination();}
                         }

                                }
                              }
   }

}
/////////////////////////////////////////////////////////////////
void TForm1::FindUselessZones(void)
{
int a=1;

while(a){
for (int i=4;i<10;i++)
 for (int j=4;j<10;j++)
    a=FindZone(i,j);
        }
}
/////////////////////////////////////////////////////////////////
void TForm1::ShowDestination(){
        GetDestinationCoordinates();
        Graphics::TBitmap* DestinationBitmap = new Graphics::TBitmap();
        DestinationBitmap->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/destination.bmp");
        Form1->ArrayModelImage->Canvas->Draw( (5+(XDestination-1)*32),(362-5-YDestination*32) ,DestinationBitmap);
        Form1->ArrayImage->Canvas->Draw( (5+(XDestination-1)*32),(362-5-YDestination*32) ,DestinationBitmap);
                delete DestinationBitmap;

        ArrayModel[XDestination][YDestination]=1;       // hard set - pozicia ciela MUSI byt volna
        Array[XDestination][YDestination]=0;            // hard set - pozicia ciela MUSI byt volna
                      }
/////////////////////////////////////////////////////////////////
void TForm1::InitializeArrayModel (int obstacles){
GetDestinationCoordinates();
        for (int i=0;i<13;i++){ArrayModel[0][i]=2;ArrayModel[12][i]=2;ArrayModel[i][0]=2;ArrayModel[i][12]=2;}
                Form1->ArrayModelImage->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/bludisko.bmp");
                        for (int i=1;i<12;i++)
                        for (int j=1;j<12;j++)
                             ArrayModel[i][j]=1;                                // 1 = zmapovane volne

    for (int i=0;i<obstacles;i++){
         int XPom=random(11);XPom++;
         int YPom=random(11);YPom++;
             if (ArrayModel[XPom][YPom]==2)i--;         // dvakrat na to iste nexem

             if ( (XPom==XStartPos  && YPom==YStartPos) || (XPom==XDestination  && YPom==YDestination))i--;               // pozicia 1,1 musi ostat volna pre robota
             else {ShowModelObstacle(XPom,YPom);ArrayModel[XPom][YPom]=2;}          // prekazka vygenerovana
                                  }
ShowDestination();
}
/////////////////////////////////////////////////////////////////
void TForm1::RefreshArrayModel(){
Form1->ArrayModelImage->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/bludisko.bmp");
for (int i=1;i<12;i++)
for (int j=1;j<12;j++)
     if (ArrayModel[i][j]==2)ShowModelObstacle(i,j);
ShowDestination();
                 }
/////////////////////////////////////////////////////////////////
void TForm1::ToggleObstacle (int X, int Y){
if (X==XDestination && Y==YDestination)ShowMessage("Nemono umiestni prekku na pozciu cea.");
if (ArrayModel[X][Y]==2)ArrayModel[X][Y]=1;
    else ArrayModel[X][Y]=2;
RefreshArrayModel();
                             }
/////////////////////////////////////////////////////////////////
void TForm1::RefreshArray(){

if (!StepCounter)Form1->ArrayImage->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/bludiskobw.bmp");
for (int i=1;i<12;i++)
for (int j=1;j<12;j++){
     if (Array[i][j]==12)ShowUseless(i,j);
     if (Array[i][j]==2)ShowObstacle(i,j);
     if (Array[i][j]==1)ShowFree(i,j);
     }

if (!StepCounter)ShowDestination();


Form1->StepCounterLabel->Caption=StepCounter;

                 }
/////////////////////////////////////////////////////////////////
float TForm1::GetDistance(int X,int Y){                   //determines distance from argument_position to destination - "E" metrics
   return (sqrt( (XDestination-X)*(XDestination-X)+(YDestination-Y)*(YDestination-Y) ));
                            }
/////////////////////////////////////////////////////////////////
float TForm1::GetDistanceToTemp(int X, int Y)
{
   return (sqrt( (TempXDestination-X)*(TempXDestination-X)+(TempYDestination-Y)*(TempYDestination-Y) ));
}
/////////////////////////////////////////////////////////////////
float TForm1::GetDistanceToRobot(int X, int Y)
{                //determines distance from argument_position to robot - "E" metrics
   return (sqrt( (XPos-X)*(XPos-X)+(YPos-Y)*(YPos-Y) ));
}
/////////////////////////////////////////////////////////////////
int TForm1::EvaluateSituation (int x,int y){
      int temp=0;


      if (orientation==1){              //toto je standardny smer, teda nic netreba modifikovat
        if (Array[x+1][y]>1)temp+=1;
        if (Array[x+1][y+1]>1)temp+=2;
        if (Array[x][y+1]>1)temp+=4;
        if (Array[x-1][y+1]>1)temp+=8;
        if (Array[x-1][y]>1)temp+=16;
                          }

      if (orientation==2){              //toto je smer E, rotacia +90 stupnov
        if (Array[x][y-1]>1)temp+=1;
        if (Array[x+1][y-1]>1)temp+=2;
        if (Array[x+1][y]>1)temp+=4;
        if (Array[x+1][y+1]>1)temp+=8;
        if (Array[x][y+1]>1)temp+=16;
                          }

      if (orientation==3){              //toto je smer S, rotacia +180 stupnov
        if (Array[x-1][y]>1)temp+=1;
        if (Array[x-1][y-1]>1)temp+=2;
        if (Array[x][y-1]>1)temp+=4;
        if (Array[x+1][y-1]>1)temp+=8;
        if (Array[x+1][y]>1)temp+=16;
                          }

      if (orientation==4){              //toto je smer W, rotacia -90 stupnov
        if (Array[x][y+1]>1)temp+=1;
        if (Array[x-1][y+1]>1)temp+=2;
        if (Array[x-1][y]>1)temp+=4;
        if (Array[x-1][y-1]>1)temp+=8;
        if (Array[x][y-1]>1)temp+=16;
                          }
        return (temp);}
/////////////////////////////////////////////////////////////////
void TForm1::UpdateLog(){

        StepCounter++;
        StepCounterDetector++;

       // BlindLoop=false;
        DistanceLog[StepCounter]=GetDistance(XPos,YPos);
        PositionLog[StepCounter]=XPos+13*YPos;
        PositionLog[StepCounterDetector]=XPos+13*YPos;

//        float scale=(Form1->ProgressGraphImage->Height-5)/GetDistance(XStartPos,YStartPos);
        float scale=(Form1->ProgressGraphImage->Height-5)/14.142;
        Form1->ProgressGraphImage->Canvas->LineTo(5+(1*StepCounter),Form1->ProgressGraphImage->Height-5-(scale*GetDistance(XPos,YPos)));

        polozka=Form1->LogListView->Items->Add();polozka->Caption=StepCounter;
                polozka->SubItems->Add(PositionLog[StepCounter]);
                if (!UsingTemporaryTarget)
                   if (PrimaryMethod!=2)
                        if (GetDistance(XPos,YPos)>1)polozka->SubItems->Add(SituationLog[StepCounterAlternate-1]);
                if (UsingTemporaryTarget || PrimaryMethod==2)polozka->SubItems->Add("---");



                if (GetDistance(XPos,YPos)>1)polozka->SubItems->Add(Round2(DistanceLog[StepCounter]));
                Form1->LogListView->Scroll(0,10);

        for (int i=0;i<StepCounterDetector;i++){
             if (PositionLog[StepCounterDetector]==PositionLog[i] && PositionLog[StepCounterDetector-1]==PositionLog[i-1] && PositionLog[StepCounterDetector-2]==PositionLog[i-2] && PositionLog[StepCounterDetector-3]==PositionLog[i-3]){BlindLoop=true;i=StepCounterDetector;StepCounterDetector=0;}
                                               }
                        }
/////////////////////////////////////////////////////////////////
void TForm1::ShowRobot(){
if (orientation==1)Form1->RobotImage->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/robotn.jpg");
if (orientation==2)Form1->RobotImage->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/robote.jpg");
if (orientation==3)Form1->RobotImage->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/robots.jpg");
if (orientation==4)Form1->RobotImage->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/robotw.jpg");

Form1->RobotImage->Visible=true;
Form1->RobotImage->Top=Form1->ArrayImage->Top+(325-((YPos-1)*32));
Form1->RobotImage->Left=Form1->ArrayImage->Left+5+((XPos-1)*32);

Form1->DistanceLabel->Caption=Round2(GetDistance(XPos,YPos));
Form1->MinStepsLabel->Caption=(abs(XPos-XDestination)+abs(YPos-YDestination));
                 }

/////////////////////////////////////////////////////////////////
void TForm1::ClearArray(){
        for (int i=0;i<13;i++){Array[0][i]=2;Array[12][i]=2;Array[i][0]=2;Array[i][12]=2;}
                Form1->ArrayImage->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/bludiskobw.bmp");
                        for (int i=1;i<12;i++)
                        for (int j=1;j<12;j++)
                             Array[i][j]=0;                                // 0 = nezmapovane

        Array[XStartPos][YStartPos]=1;                  // hard set
                 }
/////////////////////////////////////////////////////////////////
void TForm1::SetNewDestination (int X, int Y){
Array[XDestination][YDestination]=0;
if (X==XStartPos && Y==YStartPos)ShowMessage("Pozor na tomto mieste je vchodiskov pozcia robota.");
        else{

if (X>11 || X<1 || Y>11 || Y<1)ShowMessage("Cie mimo rozsah.");
        else{
            Form1->XDestinationEdit->Text=X;
            Form1->YDestinationEdit->Text=Y;
            RefreshArrayModel();
            RefreshArray();
            }}
                                     }
/////////////////////////////////////////////////////////////////
void TForm1::InitializeSystem (){

SetRecoveryMethod();
SetPrimaryMethod();
SetMetricsMethod();

Form1->LogListView->Items->Clear();

BlindLoop=false;
NotLogged=true;
UsingTemporaryTarget=false;
ModifyAmmount=0;Form1->ModifyAmmountLabel->Caption="0 krt";
for (int i=0;i<32;i++)GenotypeOccurence[i]=0;

ResetProgressGraph();
StepCounter=0;
StepCounterDetector=0;
StepCounterAlternate=0;
TargetNotReached=0;

ShowGenotype();
XPos=XStartPos;YPos=YStartPos;orientation=1;
TempXDestination=XDestination;TempYDestination=YDestination;
ClearArray();
RefreshArray();
RefreshArrayModel();
ShowRobot();
 Form1->SmallSituationImage->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/smallsituation.bmp");
                        }
/////////////////////////////////////////////////////////////////
void TForm1::ShowSmallSituation(int kod){

        Form1->CodeLabel->Caption=kod;

      bool bin[5];
        if (kod>=16){bin[4]=1; kod-=16;} else {bin[4]=0;}
        if (kod>=8) {bin[3]=1; kod-=8;}  else {bin[3]=0;}
        if (kod>=4) {bin[2]=1; kod-=4;}  else {bin[2]=0;}
        if (kod>=2) {bin[1]=1; kod-=2;}  else {bin[1]=0;}
        if (kod==1) {bin[0]=1;}          else {bin[0]=0;}
          Graphics::TBitmap* SmallObstacleBitmap = new Graphics::TBitmap();
          SmallObstacleBitmap->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/smallobs.bmp");

          //orientation = N
       if (orientation==1){
        Form1->SmallSituationImage->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/smallsituationn.bmp");

        if (bin[4])Form1->SmallSituationImage->Canvas->Draw(2,18,SmallObstacleBitmap);
        if (bin[3])Form1->SmallSituationImage->Canvas->Draw(2,2,SmallObstacleBitmap);
        if (bin[2])Form1->SmallSituationImage->Canvas->Draw(18,2,SmallObstacleBitmap);
        if (bin[1])Form1->SmallSituationImage->Canvas->Draw(34,2,SmallObstacleBitmap);
        if (bin[0])Form1->SmallSituationImage->Canvas->Draw(34,18,SmallObstacleBitmap);
                          }

          //orientation = E, rotacia 90 stupnov vpravo
       if (orientation==2){
        Form1->SmallSituationImage->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/smallsituatione.bmp");

        if (bin[4])Form1->SmallSituationImage->Canvas->Draw(18,2,SmallObstacleBitmap);
        if (bin[3])Form1->SmallSituationImage->Canvas->Draw(34,2,SmallObstacleBitmap);
        if (bin[2])Form1->SmallSituationImage->Canvas->Draw(34,18,SmallObstacleBitmap);
        if (bin[1])Form1->SmallSituationImage->Canvas->Draw(34,34,SmallObstacleBitmap);
        if (bin[0])Form1->SmallSituationImage->Canvas->Draw(18,34,SmallObstacleBitmap);
                          }

          //orientation = S, rotacia 180 stupnov
       if (orientation==3){
        Form1->SmallSituationImage->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/smallsituations.bmp");

        if (bin[4])Form1->SmallSituationImage->Canvas->Draw(34,18,SmallObstacleBitmap);
        if (bin[3])Form1->SmallSituationImage->Canvas->Draw(34,34,SmallObstacleBitmap);
        if (bin[2])Form1->SmallSituationImage->Canvas->Draw(18,34,SmallObstacleBitmap);
        if (bin[1])Form1->SmallSituationImage->Canvas->Draw(2,34,SmallObstacleBitmap);
        if (bin[0])Form1->SmallSituationImage->Canvas->Draw(2,18,SmallObstacleBitmap);
                          }

          //orientation = W, rotacia 90 stupnov vlavo
       if (orientation==4){
        Form1->SmallSituationImage->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "/Images/smallsituationw.bmp");

        if (bin[4])Form1->SmallSituationImage->Canvas->Draw(18,34,SmallObstacleBitmap);
        if (bin[3])Form1->SmallSituationImage->Canvas->Draw(2,34,SmallObstacleBitmap);
        if (bin[2])Form1->SmallSituationImage->Canvas->Draw(2,18,SmallObstacleBitmap);
        if (bin[1])Form1->SmallSituationImage->Canvas->Draw(2,2,SmallObstacleBitmap);
        if (bin[0])Form1->SmallSituationImage->Canvas->Draw(18,2,SmallObstacleBitmap);
                          }
        delete SmallObstacleBitmap;

        }
/////////////////////////////////////////////////////////////////
int TForm1::GetDistanceVector(){
    float a=GetDistance(XPos,YPos+1);     //v smere N
    float b=GetDistance(XPos+1,YPos);     //v smere E
    float c=GetDistance(XPos,YPos-1);     //v smere S
    float d=GetDistance(XPos-1,YPos);     //v smere W
    float min=15;                         //viac ako uhloprieka poa

    if (a<min)min=a;
    if (b<min)min=b;
    if (c<min)min=c;
    if (d<min)min=d;

if (orientation==1){                    //kontrola orientacie aby sa zabranilo zbytocnym toceniam
    if (min==a)return(1);
    if (min==b)return(2);
    if (min==c)return(3);
    if (min==d)return(4);
                    }

if (orientation==2){
    if (min==b)return(2);
    if (min==a)return(1);
    if (min==c)return(3);
    if (min==d)return(4);
                    }

if (orientation==3){
    if (min==c)return(3);
    if (min==a)return(1);
    if (min==b)return(2);
    if (min==d)return(4);
                    }

if (orientation==4){
    if (min==d)return(4);
    if (min==a)return(1);
    if (min==b)return(2);
    if (min==c)return(3);
                    }



    return(0);
}
/////////////////////////////////////////////////////////////////
int TForm1::GetDistanceToTempVector()
{
    float a=GetDistanceToTemp(XPos,YPos+1);     //v smere N
    float b=GetDistanceToTemp(XPos+1,YPos);     //v smere E
    float c=GetDistanceToTemp(XPos,YPos-1);     //v smere S
    float d=GetDistanceToTemp(XPos-1,YPos);     //v smere W
    float min=15;                         //viac ako uhloprieka poa

    if (a<min)min=a;
    if (b<min)min=b;
    if (c<min)min=c;
    if (d<min)min=d;

if (orientation==1){                    //kontrola orientacie aby sa zabranilo zbytocnym toceniam
    if (min==a)return(1);
    if (min==b)return(2);
    if (min==c)return(3);
    if (min==d)return(4);
                    }

if (orientation==2){
    if (min==b)return(2);
    if (min==a)return(1);
    if (min==c)return(3);
    if (min==d)return(4);
                    }

if (orientation==3){
    if (min==c)return(3);
    if (min==a)return(1);
    if (min==b)return(2);
    if (min==d)return(4);
                    }

if (orientation==4){
    if (min==d)return(4);
    if (min==a)return(1);
    if (min==b)return(2);
    if (min==c)return(3);
                    }

    return(0);
}
/////////////////////////////////////////////////////////////////
//Pozor! Nasledujuce funkcie TryMove* modifkuju globalne premenne
/////////////////////////////////////////////////////////////////
void TForm1::TryTurnLeft(){
     orientation--;
     if (orientation==0)orientation=4;
                          }
/////////////////////////////////////////////////////////////////
void TForm1::TryTurnRight(){
     orientation++;
     if (orientation==5)orientation=1;
                          }
/////////////////////////////////////////////////////////////////
void TForm1::TryMoveForward(){
     if (orientation==1){        // nie je nutna rotacia, Forward je "hore"
             if (ArrayModel[XPos][YPos+1]==1){Array[XPos][YPos+1]=1;YPos++;}
             else {Array[XPos][YPos+1]=2;}
                        }

     if (orientation==2){        // je nutna rotacia, Forward je "vpravo"
             if (ArrayModel[XPos+1][YPos]==1){Array[XPos+1][YPos]=1;XPos++;}
             else {Array[XPos+1][YPos]=2;}
                        }

     if (orientation==3){        // je nutna rotacia, Forward je "dole"
             if (ArrayModel[XPos][YPos-1]==1){Array[XPos][YPos-1]=1;YPos--;}
             else {Array[XPos][YPos-1]=2;}
                        }

     if (orientation==4){        // je nutna rotacia, Forward je "vlavo"
             if (ArrayModel[XPos-1][YPos]==1){Array[XPos-1][YPos]=1;XPos--;}
             else {Array[XPos-1][YPos]=2;}
                        }
UpdateLog();
                         }
/////////////////////////////////////////////////////////////////
int TForm1::TryMoveForwardAndLeft(){
     if (orientation==1){        // nie je nutna rotacia, Forward je "hore"
             if (ArrayModel[XPos][YPos+1]==1 && ArrayModel[XPos-1][YPos+1]==1){Array[XPos][YPos+1]=1;Array[XPos-1][YPos+1]=1;YPos++;UpdateLog();XPos--;orientation=4;UpdateLog();return(1);}
             if (ArrayModel[XPos][YPos+1]==1 && ArrayModel[XPos-1][YPos+1]==2){Array[XPos][YPos+1]=1;Array[XPos-1][YPos+1]=2;YPos++;}
             if (ArrayModel[XPos][YPos+1]==2)Array[XPos][YPos+1]==2;
                        }

     if (orientation==2){        // je nutna rotacia, Forward je "vpravo"
             if (ArrayModel[XPos+1][YPos]==1 && ArrayModel[XPos+1][YPos+1]==1){Array[XPos+1][YPos]=1;Array[XPos+1][YPos+1]=1;XPos++;UpdateLog();YPos++;orientation=1;UpdateLog();return(1);}
             if (ArrayModel[XPos+1][YPos]==1 && ArrayModel[XPos+1][YPos+1]==2){Array[XPos+1][YPos]=1;Array[XPos+1][YPos+1]=2;XPos++;}
             if (ArrayModel[XPos+1][YPos]==2)Array[XPos+1][YPos]==2;
                        }

     if (orientation==3){        // je nutna rotacia, Forward je "dole"
             if (ArrayModel[XPos][YPos-1]==1 && ArrayModel[XPos+1][YPos-1]==1){Array[XPos][YPos-1]=1;Array[XPos+1][YPos-1]=1;YPos--;UpdateLog();XPos++;orientation=2;UpdateLog();return(1);}
             if (ArrayModel[XPos][YPos-1]==1 && ArrayModel[XPos+1][YPos-1]==2){Array[XPos][YPos-1]=1;Array[XPos+1][YPos-1]=2;YPos--;}
             if (ArrayModel[XPos][YPos-1]==2)Array[XPos][YPos-1]==2;
                        }

     if (orientation==4){        // je nutna rotacia, Forward je "vlavo"
             if (ArrayModel[XPos-1][YPos]==1 && ArrayModel[XPos-1][YPos-1]==1){Array[XPos-1][YPos]=1;Array[XPos-1][YPos-1]=1;XPos--;UpdateLog();YPos--;orientation=3;UpdateLog();return(1);}
             if (ArrayModel[XPos-1][YPos]==1 && ArrayModel[XPos-1][YPos-1]==2){Array[XPos-1][YPos]=1;Array[XPos-1][YPos-1]=2;XPos--;}
             if (ArrayModel[XPos-1][YPos]==2)Array[XPos-1][YPos]==2;
                        }
UpdateLog();
return(0);
}
/////////////////////////////////////////////////////////////////
int TForm1::TryMoveForwardAndRight(void)
{
     if (orientation==1){        // nie je nutna rotacia, Forward je "hore"
             if (ArrayModel[XPos][YPos+1]==1 && ArrayModel[XPos+1][YPos+1]==1){Array[XPos][YPos+1]=1;Array[XPos+1][YPos+1]=1;YPos++;UpdateLog();XPos++;orientation=2;UpdateLog();return(1);}
             if (ArrayModel[XPos][YPos+1]==1 && ArrayModel[XPos+1][YPos+1]==2){Array[XPos][YPos+1]=1;Array[XPos+1][YPos+1]=2;YPos++;}
             if (ArrayModel[XPos][YPos+1]==2)Array[XPos][YPos+1]==2;
                        }

     if (orientation==2){        // je nutna rotacia, Forward je "vpravo"
             if (ArrayModel[XPos+1][YPos]==1 && ArrayModel[XPos+1][YPos-1]==1){Array[XPos+1][YPos]=1;Array[XPos+1][YPos-1]=1;XPos++;UpdateLog();YPos--;orientation=3;UpdateLog();return(1);}
             if (ArrayModel[XPos+1][YPos]==1 && ArrayModel[XPos+1][YPos-1]==2){Array[XPos+1][YPos]=1;Array[XPos+1][YPos-1]=2;XPos++;}
             if (ArrayModel[XPos+1][YPos]==2)Array[XPos+1][YPos]==2;
                        }

     if (orientation==3){        // je nutna rotacia, Forward je "dole"
             if (ArrayModel[XPos][YPos-1]==1 && ArrayModel[XPos-1][YPos-1]==1){Array[XPos][YPos-1]=1;Array[XPos-1][YPos-1]=1;YPos--;UpdateLog();XPos--;orientation=4;UpdateLog();return(1);}
             if (ArrayModel[XPos][YPos-1]==1 && ArrayModel[XPos-1][YPos-1]==2){Array[XPos][YPos-1]=1;Array[XPos-1][YPos-1]=2;YPos--;}
             if (ArrayModel[XPos][YPos-1]==2)Array[XPos][YPos-1]==2;

                        }

     if (orientation==4){        // je nutna rotacia, Forward je "vlavo"
             if (ArrayModel[XPos-1][YPos]==1 && ArrayModel[XPos-1][YPos+1]==1){Array[XPos-1][YPos]=1;Array[XPos-1][YPos+1]=1;XPos--;UpdateLog();YPos++;orientation=1;UpdateLog();return(1);}
             if (ArrayModel[XPos-1][YPos]==1 && ArrayModel[XPos-1][YPos+1]==2){Array[XPos-1][YPos]=1;Array[XPos-1][YPos+1]=2;XPos--;}
             if (ArrayModel[XPos-1][YPos]==2)Array[XPos-1][YPos]==2;
                        }
UpdateLog();
return(0);
}
/////////////////////////////////////////////////////////////////
int TForm1::TryMoveBackwardAndLeft(void)
{
     if (orientation==1){        // nie je nutna rotacia, Forward je "hore"
             if (ArrayModel[XPos][YPos-1]==1 && ArrayModel[XPos-1][YPos-1]==1){Array[XPos][YPos-1]=1;Array[XPos-1][YPos-1]=1;YPos--;UpdateLog();XPos--;orientation=4;UpdateLog();return(1);}
             if (ArrayModel[XPos][YPos-1]==1 && ArrayModel[XPos-1][YPos-1]==2){Array[XPos][YPos-1]=1;Array[XPos-1][YPos-1]=2;YPos--;}
             if (ArrayModel[XPos][YPos-1]==2)Array[XPos][YPos-1]==2;
                        }

     if (orientation==2){        // je nutna rotacia, Forward je "vpravo"
             if (ArrayModel[XPos-1][YPos]==1 && ArrayModel[XPos-1][YPos+1]==1){Array[XPos-1][YPos]=1;Array[XPos-1][YPos+1]=1;XPos--;UpdateLog();YPos++;orientation=1;UpdateLog();return(1);}
             if (ArrayModel[XPos-1][YPos]==1 && ArrayModel[XPos-1][YPos+1]==2){Array[XPos-1][YPos]=1;Array[XPos-1][YPos+1]=2;XPos--;}
             if (ArrayModel[XPos-1][YPos]==2)Array[XPos-1][YPos]==2;
                        }

     if (orientation==3){        // je nutna rotacia, Forward je "dole"
             if (ArrayModel[XPos][YPos+1]==1 && ArrayModel[XPos+1][YPos+1]==1){Array[XPos][YPos+1]=1;Array[XPos+1][YPos+1]=1;YPos++;UpdateLog();XPos++;orientation=2;UpdateLog();return(1);}
             if (ArrayModel[XPos][YPos+1]==1 && ArrayModel[XPos+1][YPos+1]==2){Array[XPos][YPos+1]=1;Array[XPos+1][YPos+1]=2;YPos++;}
             if (ArrayModel[XPos][YPos+1]==2)Array[XPos][YPos+1]==2;
                        }

     if (orientation==4){        // je nutna rotacia, Forward je "vlavo"
             if (ArrayModel[XPos+1][YPos]==1 && ArrayModel[XPos+1][YPos-1]==1){Array[XPos+1][YPos]=1;Array[XPos+1][YPos-1]=1;XPos++;UpdateLog();YPos--;orientation=3;UpdateLog();return(1);}
             if (ArrayModel[XPos+1][YPos]==1 && ArrayModel[XPos+1][YPos-1]==2){Array[XPos+1][YPos]=1;Array[XPos+1][YPos-1]=2;XPos++;}
             if (ArrayModel[XPos+1][YPos]==2)Array[XPos+1][YPos]==2;
                        }
UpdateLog();
return(0);
}
/////////////////////////////////////////////////////////////////
int TForm1::TryMoveBackwardAndRight(void)
{
     if (orientation==1){        // nie je nutna rotacia, Forward je "hore"
             if (ArrayModel[XPos][YPos-1]==1 && ArrayModel[XPos+1][YPos-1]==1){Array[XPos][YPos-1]=1;Array[XPos+1][YPos-1]=1;YPos--;UpdateLog();XPos++;orientation=2;UpdateLog();return(1);}
             if (ArrayModel[XPos][YPos-1]==1 && ArrayModel[XPos+1][YPos-1]==2){Array[XPos][YPos-1]=1;Array[XPos+1][YPos-1]=2;YPos--;}
             if (ArrayModel[XPos][YPos-1]==2)Array[XPos][YPos-1]==2;
                        }

     if (orientation==2){        // je nutna rotacia, Forward je "vpravo"
             if (ArrayModel[XPos-1][YPos]==1 && ArrayModel[XPos-1][YPos-1]==1){Array[XPos-1][YPos]=1;Array[XPos-1][YPos-1]=1;XPos--;UpdateLog();YPos--;orientation=3;UpdateLog();return(1);}
             if (ArrayModel[XPos-1][YPos]==1 && ArrayModel[XPos-1][YPos-1]==2){Array[XPos-1][YPos]=1;Array[XPos-1][YPos-1]=2;XPos--;}
             if (ArrayModel[XPos-1][YPos]==2)Array[XPos-1][YPos]==2;
                        }

     if (orientation==3){        // je nutna rotacia, Forward je "dole"
             if (ArrayModel[XPos][YPos+1]==1 && ArrayModel[XPos+1][YPos-1]==1){Array[XPos][YPos+1]=1;Array[XPos+1][YPos-1]=1;YPos++;UpdateLog();XPos--;orientation=4;UpdateLog();return(1);}
             if (ArrayModel[XPos][YPos+1]==1 && ArrayModel[XPos+1][YPos-1]==2){Array[XPos][YPos+1]=1;Array[XPos+1][YPos-1]=2;YPos++;}
             if (ArrayModel[XPos][YPos+1]==2)Array[XPos][YPos+1]==2;
                        }

     if (orientation==4){        // je nutna rotacia, Forward je "vlavo"
             if (ArrayModel[XPos+1][YPos]==1 && ArrayModel[XPos+1][YPos+1]==1){Array[XPos+1][YPos]=1;Array[XPos+1][YPos+1]=1;XPos++;UpdateLog();YPos++;orientation=1;UpdateLog();return(1);}
             if (ArrayModel[XPos+1][YPos]==1 && ArrayModel[XPos+1][YPos+1]==2){Array[XPos+1][YPos]=1;Array[XPos+1][YPos+1]=2;XPos++;}
             if (ArrayModel[XPos+1][YPos]==2)Array[XPos+1][YPos]==2;
                        }
UpdateLog();
return(0);
}
/////////////////////////////////////////////////////////////////
void TForm1::TryMoveBackward(){
     if (orientation==2){        // je nutna rotacia, Backward je "vlavo"
             if (ArrayModel[XPos-1][YPos]==1){Array[XPos-1][YPos]=1;XPos--;}
             else {Array[XPos-1][YPos]=2;}
                        }

     if (orientation==3){        // je nutna rotacia, Backward je "hore"
             if (ArrayModel[XPos][YPos+1]==1){Array[XPos][YPos+1]=1;YPos++;}
             else {Array[XPos][YPos+1]=2;}
                        }

     if (orientation==4){        // je nutna rotacia, Backward je "vpravo"
             if (ArrayModel[XPos+1][YPos]==1){Array[XPos+1][YPos]=1;XPos++;}
             else {Array[XPos+1][YPos]=2;}
                        }

     if (orientation==1){        // nie je nutna rotacia, Backward je "dole"
             if (ArrayModel[XPos][YPos-1]==1){Array[XPos][YPos-1]=1;YPos--;}
             else {Array[XPos][YPos-1]=2;}
                        }

UpdateLog();
                         }
/////////////////////////////////////////////////////////////////
int TForm1::ExecuteSimulationStep(){
     if (NextStepCode==0){StopAutoTimer();ShowMessage("Nebol navrhnut al krok. Nevykonm iadnu zmenu.");
                      return(0);}

        ShowGenotype();         //update

     if (NextStepCode==1)orientation=1;
     if (NextStepCode==2)orientation=2;
     if (NextStepCode==3)orientation=3;
     if (NextStepCode==4)orientation=4;

     if (NextStepCode==11 && orientation==1){TryMoveForward();NextStepCode=0;}
     if (NextStepCode==11 && orientation==2){TryTurnLeft();TryMoveForward();NextStepCode=0;}
     if (NextStepCode==11 && orientation==3){TryMoveBackward();NextStepCode=0;}
     if (NextStepCode==11 && orientation==4){TryTurnRight();TryMoveForward();NextStepCode=0;}

     if (NextStepCode==12 && orientation==1){TryTurnRight();TryMoveForward();NextStepCode=0;}
     if (NextStepCode==12 && orientation==2){TryMoveForward();NextStepCode=0;}
     if (NextStepCode==12 && orientation==3){TryTurnLeft();TryMoveForward();NextStepCode=0;}
     if (NextStepCode==12 && orientation==4){TryMoveBackward();NextStepCode=0;}

     if (NextStepCode==13 && orientation==1){TryMoveBackward();NextStepCode=0;}
     if (NextStepCode==13 && orientation==2){TryTurnRight();TryMoveForward();NextStepCode=0;}
     if (NextStepCode==13 && orientation==3){TryMoveForward();NextStepCode=0;}
     if (NextStepCode==13 && orientation==4){TryTurnLeft();TryMoveForward();NextStepCode=0;}

     if (NextStepCode==14 && orientation==1){TryTurnLeft();TryMoveForward();NextStepCode=0;}
     if (NextStepCode==14 && orientation==2){TryMoveBackward();NextStepCode=0;}
     if (NextStepCode==14 && orientation==3){TryTurnRight();TryMoveForward();NextStepCode=0;}
     if (NextStepCode==14 && orientation==4){TryMoveForward();NextStepCode=0;}

     if (NextStepCode==101){TryMoveForward();}
     if (NextStepCode==102){TryTurnRight();TryMoveForward();}
     if (NextStepCode==103){TryTurnLeft();TryMoveForward();}
     if (NextStepCode==104){TryMoveBackward();}
     if (NextStepCode==105){TryMoveForwardAndLeft();}
     if (NextStepCode==106){TryMoveForwardAndRight();}
     if (NextStepCode==107){TryTurnLeft();TryMoveForwardAndRight();}
     if (NextStepCode==108){TryTurnRight();TryMoveForwardAndLeft();}
     if (NextStepCode==109){TryTurnLeft();TryMoveForwardAndLeft();}
     if (NextStepCode==110){TryTurnRight();TryMoveForwardAndRight();}
     if (NextStepCode==111){TryMoveBackwardAndLeft();}
     if (NextStepCode==112){TryMoveBackwardAndRight();}



     RefreshArray();
     ShowRobot();
     ShowSmallSituation(EvaluateSituation(XPos,YPos));

Form1->ExplanationMemo->Clear();
Form1->ExplanationMemo->Lines->Add("Navrhovan krok bol vykonan");
NotLogged=true;

NextStepCode=0;
return(1);
}
/////////////////////////////////////////////////////////////////
int TForm1::ExecuteRealStep(){
     if (NextStepCode==0){SuggestStepClick(Form1);
                      return(0);}
      if (NextStepCode == 10)
         RealTimer->Enabled = true;

        ShowGenotype();         //update

      if (orientation == 1) {

          if (NextStepCode==2){ComPort1->WriteStr('r');RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
          if (NextStepCode==3){ComPort1->WriteStr('t');RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
          if (NextStepCode==4){ComPort1->WriteStr('l');RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}

      }

      if (orientation == 2) {

          if (NextStepCode==1){ComPort1->WriteStr('l');RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
          if (NextStepCode==3){ComPort1->WriteStr('r');RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
          if (NextStepCode==4){ComPort1->WriteStr('t');RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      }

      if (orientation == 3) {

          if (NextStepCode==1){ComPort1->WriteStr('t');RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
          if (NextStepCode==2){ComPort1->WriteStr('l');RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
          if (NextStepCode==4){ComPort1->WriteStr('r');RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      }

      if (orientation == 4) {

          if (NextStepCode==1){ComPort1->WriteStr('r');RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
          if (NextStepCode==2){ComPort1->WriteStr('t');RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
          if (NextStepCode==3){ComPort1->WriteStr('l');RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      }

     if(NextStepCode > 0 && NextStepCode <5)
      orientation = NextStepCode;

     int temp_orientation = orientation;

     if (orientation == 1) {
      if (NextStepCode==11) {ComPort1->WriteStr('f'); temp_orientation = 1;}
      if (NextStepCode==12) {ComPort1->WriteStr('h'); temp_orientation = 2;}
      if (NextStepCode==13) {ComPort1->WriteStr('b'); temp_orientation = 1;}
      if (NextStepCode==14) {ComPort1->WriteStr('g'); temp_orientation = 4;}
                            }

     if (orientation == 2) {
      if (NextStepCode==11) {ComPort1->WriteStr('g'); temp_orientation = 1;}
      if (NextStepCode==12) {ComPort1->WriteStr('f'); temp_orientation = 2;}
      if (NextStepCode==13) {ComPort1->WriteStr('h'); temp_orientation = 3;}
      if (NextStepCode==14) {ComPort1->WriteStr('b'); temp_orientation = 2;}
                            }

     if (orientation == 3) {
      if (NextStepCode==11) {ComPort1->WriteStr('b'); temp_orientation = 3;}
      if (NextStepCode==12) {ComPort1->WriteStr('g'); temp_orientation = 2;}
      if (NextStepCode==13) {ComPort1->WriteStr('f'); temp_orientation = 3;}
      if (NextStepCode==14) {ComPort1->WriteStr('h'); temp_orientation = 4;}
                            }

     if (orientation == 4) {
      if (NextStepCode==11) {ComPort1->WriteStr('h'); temp_orientation = 1;}
      if (NextStepCode==12) {ComPort1->WriteStr('b'); temp_orientation = 4;}
      if (NextStepCode==13) {ComPort1->WriteStr('g'); temp_orientation = 3;}
      if (NextStepCode==14) {ComPort1->WriteStr('f'); temp_orientation = 4;}
                            }

     orientation = temp_orientation;

     if (NextStepCode==101){ComPort1->WriteStr('f');}
     if (NextStepCode==102){ComPort1->WriteStr('h');}
     if (NextStepCode==103){ComPort1->WriteStr('g');}
     if (NextStepCode==104){ComPort1->WriteStr('b');}

     if (NextStepCode==105){ComPort1->WriteStr('f'); Step = 1;}
     if (NextStepCode==106){ComPort1->WriteStr('f'); Step = 1;}
     if (NextStepCode==107){ComPort1->WriteStr('g'); Step = 1;}
     if (NextStepCode==108){ComPort1->WriteStr('h'); Step = 1;}
     if (NextStepCode==109){ComPort1->WriteStr('g'); Step = 1;}
     if (NextStepCode==110){ComPort1->WriteStr('h'); Step = 1;}
     if (NextStepCode==111){ComPort1->WriteStr('b'); Step = 1;}
     if (NextStepCode==112){ComPort1->WriteStr('b'); Step = 1;}



return(1);


                           }
/////////////////////////////////////////////////////////////////
int TForm1::SearchKnowledgeBase (int SituationCode){
        return(Genotype[SituationCode]);
                                           }
/////////////////////////////////////////////////////////////////
String TForm1::TellMeNextMovement(int _NextStepCode){
        switch (_NextStepCode){
        case 101 :return("krok vpred");
        case 102 :return("otoenie doava a krok vpred");
        case 103 :return("otoenie doprava a krok vpred");
        case 104 :return("krok vzad");
        case 105 :return("krok vpred, otoenie doava a krok vpred");
        case 106 :return("krok vpred, otoenie doprava a krok vpred");
        case 107 :return("otoenie doava, krok vpred, otoenie doprava a krok vpred");
        case 108 :return("otoenie doprava, krok vpred, otoenie doava a krok vpred");
        case 109 :return("otoenie doava, krok vpred, otoenie doava a krok vpred");
        case 110 :return("otoenie doprava, krok vpred, otoenie doprava a krok vpred");
        case 111 :return("krok vzad, otoenie doava a krok vpred");
        case 112 :return("krok vzad, otoenie doprava a krok vpred");
        default  :return("_out of code_ no such a movement");
                              }
                  }
/////////////////////////////////////////////////////////////////
int TForm1::FindCheckTemp (){

 //       RefreshArray();
        int XRet=0,YRet=0;
        for (int j=1;j<13;j++){
          for (int i=1;i<13;i++){

  if (Array[i-1][j]==0 && Array[i][j]==1){XRet=i-1;YRet=j;}
  if (Array[i+1][j]==0 && Array[i][j]==1){XRet=i+1;YRet=j;}
  if (Array[i][j-1]==0 && Array[i][j]==1){XRet=i;YRet=j-1;}
  if (Array[i][j+1]==0 && Array[i][j]==1){XRet=i;YRet=j+1;}
                                }}
if (XRet==XDestination && YRet==YDestination)return(3);         //3 stands for Destination

if (XRet==0 && YRet==0)return(0);                               //0 stands for Neexistuje dalsi krok
    else{
        Array[XRet][YRet]=ArrayModel[XRet][YRet];
        return(1);
        }
}
/////////////////////////////////////////////////////////////////
int TForm1::ValidatePosition(int i, int j)
{
  if (Array[i-1][j]==1 && Array[i][j]==0)return(1);
  if (Array[i+1][j]==1 && Array[i][j]==0)return(1);
  if (Array[i][j-1]==1 && Array[i][j]==0)return(1);
  if (Array[i][j+1]==1 && Array[i][j]==0)return(1);
  return(0);
}
/////////////////////////////////////////////////////////////////
int TForm1::CheckLab()
{

int a=1;
while (a==1){a=FindCheckTemp();}
   if (a==3)return(1);
   if (a==0)return(0);
InitializeSystem();
            return(99);                                 //99 stands for error
}
/////////////////////////////////////////////////////////////////
void TForm1::StopAutoTimer()
{
        Form1->AutoStepCheckBox->Checked=false;
        Form1->AutoStepTimer->Enabled=false;
        Form1->RealTimer->Enabled = false;
}
/////////////////////////////////////////////////////////////////
//Pozor funkcia SetTemporaryTarget modifikuje globalne premenne TempXTarget a TempYTarget
/////////////////////////////////////////////////////////////////
void TForm1::SetTemporaryTarget(int X,int Y)    // X Y su pozicie robota aby boli navrhovane optimalne nahradne ciele
{
float min=999;
float MultiDistanceArray[13][13];
for (int i=0;i<13;i++)
 for (int j=0;j<13;j++)
   MultiDistanceArray[i][j]=999;

for (int i=0;i<13;i++)
 for (int j=0;j<13;j++)
         MultiDistanceArray[i][j]=GetDistance(i,j);

for (int i=0;i<13;i++)
 for (int j=0;j<13;j++){
   MultiDistanceArray[i][j]+=GetDistanceToRobot(i,j);
   if(GetDistance(i,j)==0)MultiDistanceArray[i][j]=999;
   if(GetDistanceToRobot(i,j)==0)MultiDistanceArray[i][j]=999;
   if (i==TempXDestination && j==TempYDestination)MultiDistanceArray[i][j]=998;
                        }

TempXDestination=99;
TempYDestination=99;

for (int i=0;i<13;i++){
 for (int j=0;j<13;j++){
   Form1->StringGrid1->Cells[i][12-j]=Round2(MultiDistanceArray[i][j]);

   if (ValidatePosition(i,j)){

   if (MultiDistanceArray[i][j]==min && GetDistance(i,j)<GetDistance(TempXDestination,TempYDestination) )
          {min=MultiDistanceArray[i][j];TempXDestination=i;TempYDestination=j;}


   if (MultiDistanceArray[i][j]<min){
               min=MultiDistanceArray[i][j];
               TempXDestination=i;
               TempYDestination=j;
                                    }
                             }
                        }}

ShowTemp(TempXDestination,TempYDestination);
if (min==999){StopAutoTimer();ShowMessage("Nem rieenie");}

if (TargetNotReached>3)SetSomeTarget();

}
/////////////////////////////////////////////////////////////////
//Pozor funkcia SetNearestTemporaryTarget modifikuje globalne premenne TempXTarget a TempYTarget
/////////////////////////////////////////////////////////////////
void TForm1::SetNearestTemporaryTarget(int X, int Y)       // Nearest To Robot
{
float min=999;
float MultiDistanceArray[13][13];

for (int i=0;i<13;i++)
 for (int j=0;j<13;j++)
   MultiDistanceArray[i][j]=999;

for (int i=0;i<13;i++)
 for (int j=0;j<13;j++){
         MultiDistanceArray[i][j]=GetDistanceToRobot(i,j);
         if(GetDistanceToRobot(i,j)==0)MultiDistanceArray[i][j]=999;
         if (i==TempXDestination && j==TempYDestination)MultiDistanceArray[i][j]=998;
                        }

TempXDestination=99;
TempYDestination=99;

for (int i=0;i<13;i++){
 for (int j=0;j<13;j++){
   Form1->StringGrid1->Cells[i][12-j]=Round2(MultiDistanceArray[i][j]);

   if (ValidatePosition(i,j)){

            if (MultiDistanceArray[i][j]==min && GetDistance(i,j)<GetDistance(TempXDestination,TempYDestination) )
                    {min=MultiDistanceArray[i][j];TempXDestination=i;TempYDestination=j;}

   if (MultiDistanceArray[i][j]<min){
        min=MultiDistanceArray[i][j];
        TempXDestination=i;
        TempYDestination=j;
        }}
                        }}
ShowTemp(TempXDestination,TempYDestination);
if (min==999){StopAutoTimer();ShowMessage("Nem rieenie");}



if (TargetNotReached>3)SetSomeTarget();

}
/////////////////////////////////////////////////////////////////
//Pozor funkcia SetNearestToDestinationTemporaryTarget modifikuje globalne premenne TempXTarget a TempYTarget
/////////////////////////////////////////////////////////////////
void TForm1::SetNearestToDestinationTemporaryTarget(int X, int Y)
{
float min=999;
float MultiDistanceArray[13][13];

for (int i=0;i<13;i++)
 for (int j=0;j<13;j++)
   MultiDistanceArray[i][j]=999;

for (int i=0;i<13;i++)
 for (int j=0;j<13;j++){
         MultiDistanceArray[i][j]=GetDistance(i,j);
         if(GetDistance(i,j)==0)MultiDistanceArray[i][j]=999;
         if (i==TempXDestination && j==TempYDestination)MultiDistanceArray[i][j]=998;
                        }

TempXDestination=99;
TempYDestination=99;                        

for (int i=0;i<13;i++){
 for (int j=0;j<13;j++){
   Form1->StringGrid1->Cells[i][12-j]=Round2(MultiDistanceArray[i][j]);

   if (ValidatePosition(i,j)){

      if (MultiDistanceArray[i][j]==min && GetDistanceToRobot(i,j)<GetDistanceToRobot(TempXDestination,TempYDestination) )
         {min=MultiDistanceArray[i][j];TempXDestination=i;TempYDestination=j;}


  if (MultiDistanceArray[i][j]<min){
        min=MultiDistanceArray[i][j];
        TempXDestination=i;
        TempYDestination=j;
        }}
                        }}
ShowTemp(TempXDestination,TempYDestination);
if (min==999){StopAutoTimer();ShowMessage("Nem rieenie");}

if (TargetNotReached>3)SetSomeTarget();

}
/////////////////////////////////////////////////////////////////
//Pozor funkcia SetRandomTemporaryTarget modifikuje globalne premenne TempXTarget a TempYTarget
/////////////////////////////////////////////////////////////////
void TForm1::SetRandomTemporaryTarget(int X, int Y)
{
float min=999;
float MultiDistanceArray[13][13];
for (int i=0;i<13;i++)
 for (int j=0;j<13;j++)
   MultiDistanceArray[i][j]=999;

for (int i=0;i<13;i++)
 for (int j=0;j<13;j++){
         MultiDistanceArray[i][j]=GetDistance(i,j);
         if(GetDistance(i,j)==0)MultiDistanceArray[i][j]=999;
         if (i==TempXDestination && j==TempYDestination)MultiDistanceArray[i][j]=998;
                        }
int a=99;
int b=99;

//   int a=random(13)+1;
//   int b=random(13)+1;


   bool TemporaryTargetExists=false;
for (int i=0;i<13;i++)
 for (int j=0;j<13;j++){
   if (ValidatePosition(i,j))TemporaryTargetExists=true;
                       }

if (TemporaryTargetExists){
while(!ValidatePosition(a,b)){
   a=random(12)+1;
   b=random(12)+1;
   }
                          }

        min=MultiDistanceArray[a][b];
        TempXDestination=a;
        TempYDestination=b;

ShowTemp(TempXDestination,TempYDestination);
if (min==999){StopAutoTimer();ShowMessage("Nem rieenie");}

if (TargetNotReached>3)SetSomeTarget();

}
/////////////////////////////////////////////////////////////////
void TForm1::SetSomeTarget()
{
int a=99;
int b=99;

//   int a=random(13)+1;
//   int b=random(13)+1;

while(Array[a][b]!=1){
   a=random(12)+1;
   b=random(12)+1;
   }
                          
        TempXDestination=a;
        TempYDestination=b;

ShowTemp(TempXDestination,TempYDestination);

}
/////////////////////////////////////////////////////////////////
int TForm1::SuggestValidMovement(int X, int Y)
{
       float N=0;
       float E=0;
       float S=0;
       float W=0;

if (UsingTemporaryTarget){
       N=GetDistanceToTemp(X,Y+1);
       E=GetDistanceToTemp(X+1,Y);
       S=GetDistanceToTemp(X,Y-1);
       W=GetDistanceToTemp(X-1,Y);
                         }

else{
       N=GetDistance(X,Y+1);
       E=GetDistance(X+1,Y);
       S=GetDistance(X,Y-1);
       W=GetDistance(X-1,Y);
                           }

if (Array[X][Y+1]>1)N=999;
if (Array[X+1][Y]>1)E=999;
if (Array[X][Y-1]>1)S=999;
if (Array[X-1][Y]>1)W=999;

        // uprednostim nezmapovane (poriadne)
if (Array[X][Y+1]==0)N-=0.01;
if (Array[X+1][Y]==0)E-=0.01;
if (Array[X][Y-1]==0)S-=0.01;
if (Array[X-1][Y]==0)W-=0.01;

float min=99;
if (N<min)min=N;
if (E<min)min=E;
if (S<min)min=S;
if (W<min)min=W;

if (min==N)return(11);
if (min==E)return(12);
if (min==S)return(13);
if (min==W)return(14);

return(99);

}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
randomize();
LoadGenotype();
InitializeArrayModel(0);
InitializeSystem();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ArrayModelImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        int XPosClicked=((X-6)/32)+1;
            if (X<5)XPosClicked=0;
        int YPosClicked=10-((Y-6)/32)+1;
            if (Y<5)XPosClicked=12;

if (Button==0)ToggleObstacle(XPosClicked,YPosClicked);
if (Button==1)SetNewDestination(XPosClicked,YPosClicked);

}
//---------------------------------------------------------------------------


void __fastcall TForm1::GenerateModelButtonClick(TObject *Sender)
{
GetDestinationCoordinates();
InitializeArrayModel(StrToInt(ObstacleAmmountEdit->Text));
InitializeSystem();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ObstacleAmmountEditKeyPress(TObject *Sender,
      char &Key)
{
if (ObstacleAmmountEdit->Text=="")ObstacleAmmountEdit->Text=0;
if (StrToInt(ObstacleAmmountEdit->Text) > ObstacleLimit ){
        ShowMessage("Prli vea prekok.");
        ObstacleAmmountEdit->Text=ObstacleLimit;}

if ( (Key<'0' && Key>31) || Key>'9')Key= 0;
if ( Key== 0x0D )GenerateModelButtonClick(Form1);

ObstacleAmmountEdit->Text=(StrToInt(ObstacleAmmountEdit->Text));

}
//---------------------------------------------------------------------------
void __fastcall TForm1::ObstacleAmmountEditExit(TObject *Sender)
{
if (ObstacleAmmountEdit->Text=="")ObstacleAmmountEdit->Text=0;
if (StrToInt(ObstacleAmmountEdit->Text) > ObstacleLimit ){
        ShowMessage("Prli vea prekok.");
        ObstacleAmmountEdit->Text=ObstacleLimit;}

}
//---------------------------------------------------------------------------

void __fastcall TForm1::XDestinationEditKeyPress(TObject *Sender,
      char &Key)
{
if (XDestinationEdit->Text=="")XDestinationEdit->Text=11;
if ( (StrToInt(XDestinationEdit->Text) > 11) || (StrToInt(XDestinationEdit->Text) < 1) ){
        ShowMessage("Cie mimo rozsah.");
        XDestinationEdit->Text=11;}

if ( (Key<'0' && Key>31) || Key>'9')Key= 0;
if ( Key== 0x0D ){SetNewDestination(StrToInt(XDestinationEdit->Text),StrToInt(YDestinationEdit->Text));}

XDestinationEdit->Text=(StrToInt(XDestinationEdit->Text));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::XDestinationEditExit(TObject *Sender)
{
if (XDestinationEdit->Text=="")XDestinationEdit->Text=0;
if ( (StrToInt(XDestinationEdit->Text) > 11) || (StrToInt(XDestinationEdit->Text) < 1) ){
        ShowMessage("Cie mimo rozsah.");
        XDestinationEdit->Text=11;}
SetNewDestination(StrToInt(XDestinationEdit->Text),StrToInt(YDestinationEdit->Text));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::YDestinationEditKeyPress(TObject *Sender,
      char &Key)
{
if (YDestinationEdit->Text=="")YDestinationEdit->Text=11;
if ( (StrToInt(YDestinationEdit->Text) > 11) || (StrToInt(YDestinationEdit->Text) < 1) ){
        ShowMessage("Cie mimo rozsah.");
        YDestinationEdit->Text=11;}

if ( (Key<'0' && Key>31) || Key>'9')Key= 0;
if ( Key== 0x0D ){SetNewDestination(StrToInt(XDestinationEdit->Text),StrToInt(YDestinationEdit->Text));}

YDestinationEdit->Text=(StrToInt(YDestinationEdit->Text));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::YDestinationEditExit(TObject *Sender)
{
if (YDestinationEdit->Text=="")YDestinationEdit->Text=0;
if ( (StrToInt(YDestinationEdit->Text) > 11) || (StrToInt(YDestinationEdit->Text) < 1) ){
        ShowMessage("Cie mimo rozsah.");
        YDestinationEdit->Text=11;}
SetNewDestination(StrToInt(XDestinationEdit->Text),StrToInt(YDestinationEdit->Text));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::InitializeButtonClick(TObject *Sender)
{
InitializeSystem();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::SuggestNextStepGeneticButtonClick(TObject *Sender)
{
if (BlindHolesCheckBox->Checked)FindUselessFields();
if (ZonesCheckBox->Checked)FindUselessZones();

        // Som v cieli
        if (XPos==XDestination && YPos==YDestination){
        StopAutoTimer();
        ExplanationMemo->Clear();
        ExplanationMemo->Lines->Add("Robot sa nachdza v cieli");
        ShowMessage("Robot dorazil do ciea.");
        goto EndOfSuggestion;}


    if (Array[XPos+1][YPos]>1 && Array[XPos-1][YPos]>1 && Array[XPos][YPos-1]>1 && Array[XPos][YPos+1]>1){StopAutoTimer();ShowMessage("Bludisko nem rieenie");}

if (StepCounter>500){StopAutoTimer();
                     ShowMessage("Robot nedorazil do ciea ani po 500 krokoch, algoritmus je pravdepodobne prli slab.");
                     }

if(AutoStepCheckBox->Checked && SimulateRadioButton->Checked){AutoStepTimer->Enabled=true;
                              AutoStepTimer->Interval=5000-AutoStepSpeedTrack->Position;}
   else AutoStepTimer->Enabled=false;

if(AutoStepCheckBox->Checked && RealityRadioButton->Checked){AutoStepTimerReal->Enabled=true;
                              AutoStepTimerReal->Interval=6000-AutoStepSpeedTrack->Position;}
   else AutoStepTimerReal->Enabled=false;



// Step 0 - ak pouzivam metodu docasneho ciela, oznamim to
if (UsingTemporaryTarget && BlindLoop){

                          if (GetDistanceToTemp(XPos,YPos)==1){
                          ExplanationMemo->Lines->Add("Nachdzam sa jeden krok od doasnho ciea, navrhujem vs do doasnho ciea.");
                          if (XPos+1==TempXDestination && YPos==TempYDestination)NextStepCode=12;
                          if (XPos==TempXDestination && YPos+1==TempYDestination)NextStepCode=11;
                          if (XPos-1==TempXDestination && YPos==TempYDestination)NextStepCode=14;
                          if (XPos==TempXDestination && YPos-1==TempYDestination)NextStepCode=13;
                          UsingTemporaryTarget=false;
                          goto EndOfSuggestion;}

                          ExplanationMemo->Lines->Add("Je zvolen nhradn cie "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination));
                          if (MetricsMethod==1)SetNearestTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==2)SetNearestToDestinationTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==3)SetTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==4)SetRandomTemporaryTarget(XPos,YPos);
                          TargetNotReached++;
                          UsingTemporaryTarget=true;
                          BlindLoop=false;
                            if (TempXDestination!=99 || TempYDestination!=99)ExplanationMemo->Lines->Add("Nastavujem nov doasn cie "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination));
                               else {ExplanationMemo->Lines->Add("Toto bludisko nem rieenie");StopAutoTimer();}
                          NextStepCode=10;
                          goto EndOfSuggestion;
                                     }

if (UsingTemporaryTarget && !BlindLoop){
        ExplanationMemo->Clear();
        if (TempXDestination==99 && TempYDestination==99){ExplanationMemo->Lines->Add("Toto bludisko nem rieenie");StopAutoTimer();}
            else{

    ExplanationMemo->Lines->Add("Je zvolen nhradn cie "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination));
        if (GetDistanceToTemp(XPos,YPos)==1){
        ExplanationMemo->Lines->Add("Nachdzam sa jeden krok od doasnho ciea, navrhujem vs do doasnho ciea.");
        if (XPos+1==TempXDestination && YPos==TempYDestination)NextStepCode=12;
        if (XPos==TempXDestination && YPos+1==TempYDestination)NextStepCode=11;
        if (XPos-1==TempXDestination && YPos==TempYDestination)NextStepCode=14;
        if (XPos==TempXDestination && YPos-1==TempYDestination)NextStepCode=13;
        //UsingTemporaryTarget=false;
        goto EndOfSuggestion;}

        if (XPos==TempXDestination && YPos==TempYDestination){
        ExplanationMemo->Clear();
        ExplanationMemo->Lines->Add("Robot dorazil do doasnho ciea.");
        TargetNotReached=0;
        NextStepCode=10;
        UsingTemporaryTarget=false;
        goto EndOfSuggestion;}


        if (GetDistanceToTemp(XPos,YPos)>1){
        // Navrh dalsieho kroku do docasneho ciela na zaklade genetickej bazy
        NextStepCode=0;                                 // 0 - nebol navrhnuty ziadny dalsi krok
        ShowSmallSituation(EvaluateSituation(XPos,YPos));

        ExplanationMemo->Clear();
        if (orientation==1)ExplanationMemo->Lines->Add("Robot je orientovan na sever");
        if (orientation==2)ExplanationMemo->Lines->Add("Robot je orientovan na vchod");
        if (orientation==3)ExplanationMemo->Lines->Add("Robot je orientovan na juh");
        if (orientation==4)ExplanationMemo->Lines->Add("Robot je orientovan na zpad");
        ExplanationMemo->Lines->Add("Robot sa nachdza v situcii "+IntToStr(EvaluateSituation(XPos,YPos)) );

        if (GetDistanceToTempVector()==1)ExplanationMemo->Lines->Add("Najlepie by bolo dosta sa na sever, vzdialenos (do doasnho ciea "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination)+") by tak klesla na "+FloatToStr(Round2(GetDistanceToTemp(XPos,YPos+1))) );
        if (GetDistanceToTempVector()==2)ExplanationMemo->Lines->Add("Najlepie by bolo dosta sa na vchod, vzdialenos (do doasnho ciea "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination)+") by tak klesla na "+FloatToStr(Round2(GetDistanceToTemp(XPos+1,YPos))) );
        if (GetDistanceToTempVector()==3)ExplanationMemo->Lines->Add("Najlepie by bolo dosta sa na juh, vzdialenos (do doasnho ciea "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination)+") by tak klesla na "+FloatToStr(Round2(GetDistanceToTemp(XPos,YPos-1))) );
        if (GetDistanceToTempVector()==4)ExplanationMemo->Lines->Add("Najlepie by bolo dosta sa na zpad, vzdialenos (do doasnho ciea "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination)+") by tak klesla na "+FloatToStr(Round2(GetDistanceToTemp(XPos-1,YPos))) );

        if (GetDistanceToTempVector()==orientation){NextStepCode=100+SearchKnowledgeBase(EvaluateSituation(XPos,YPos));
                                      ExplanationMemo->Lines->Add("Na zklade bzy znalost sa ukazuje vhodn poui manver ."+IntToStr(NextStepCode)+" - " + TellMeNextMovement(NextStepCode) );}

        // Nie je dobra orientacia - to co treba urobit je natocit robota
        if (orientation!=GetDistanceToTempVector()){
        ExplanationMemo->Lines->Add("Kee robot nie je orientovan tmto smerom, navrhujem sa otoi do tohto smeru, aby bolo mon poui databzu znalost");
        NextStepCode=GetDistanceToTempVector();       // 1 - otoc sa na sever
                                                // 2 - otoc sa na zapad
                                                // 3 - otoc sa na juh
                                                // 4 - otoc sa na vychod
                                      }}

        //StopAutoTimer();
    goto EndOfSuggestion;
                 }
                         }




// Step 1 - ak som jeden krok od ciela, nic neriesim a proste vojdem do ciela
if (GetDistance(XPos,YPos)==1){
        ExplanationMemo->Lines->Add("Nachdzam sa jeden krok od ciea, navrhujem vs do ciea.");
        if (XPos+1==XDestination && YPos==YDestination)NextStepCode=12;
        if (XPos==XDestination && YPos+1==YDestination)NextStepCode=11;
        if (XPos-1==XDestination && YPos==YDestination)NextStepCode=14;
        if (XPos==XDestination && YPos-1==YDestination)NextStepCode=13;
        goto EndOfSuggestion;}

// Doslo k zacykleniu je nutne navrhnut nejake rozumne riesenie
if (BlindLoop){ExplanationMemo->Lines->Add("Dolo k zacykleniu.");
               if (RecoveryMethod==0){StopAutoTimer();ShowMessage("Nebola zvolen metda zotavenia sa zo zacyklenia, algoritmus kon nespene.");}

               if (RecoveryMethod==1){
                       ExplanationMemo->Lines->Add("Rotciou modifikujem genetick informciu v znalostnej bze na gne slo "+IntToStr(SituationLog[StepCounterAlternate-1]));
                       Genotype[SituationLog[StepCounterAlternate-1]]=RotateGenotype(SituationLog[StepCounterAlternate-1]);
                       ModifyAmmount++;
                       Form1->ModifyAmmountLabel->Caption=IntToStr(ModifyAmmount)+(" krt");
                       BlindLoop=false;
                       NextStepCode=10;}

               if (RecoveryMethod==2){
                       ExplanationMemo->Lines->Add("Nhodne modifikujem genetick informciu v znalostnej bze na gne slo "+IntToStr(SituationLog[StepCounterAlternate-1]));
                       Genotype[SituationLog[StepCounterAlternate-1]]=GenerateGen(SituationLog[StepCounterAlternate-1]);
                       ModifyAmmount++;
                       Form1->ModifyAmmountLabel->Caption=IntToStr(ModifyAmmount)+(" krt");
                       BlindLoop=false;
                       NextStepCode=10;}
               if (RecoveryMethod==3){
                          if (MetricsMethod==1)SetNearestTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==2)SetNearestToDestinationTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==3)SetTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==4)SetRandomTemporaryTarget(XPos,YPos);

                       UsingTemporaryTarget=true;
                       BlindLoop=false;
                       if (TempXDestination!=99 || TempYDestination!=99)ExplanationMemo->Lines->Add("Nastavujem nov doasn cie "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination));
                          else {ExplanationMemo->Lines->Add("Toto bludisko nem rieenie");StopAutoTimer();}
                       NextStepCode=10;
                                     }

               goto EndOfSuggestion; }


if (GetDistance(XPos,YPos)>1){
// Navrh dalsieho kroku na zaklade genetickej bazy
NextStepCode=0;                                 // 0 - nebol navrhnuty ziadny dalsi krok
ShowSmallSituation(EvaluateSituation(XPos,YPos));

if (NotLogged){
        NotLogged=false;
        if (EvaluateSituation(XPos,YPos)==0)GenotypeOccurence[0]++;
        if (EvaluateSituation(XPos,YPos)==1)GenotypeOccurence[1]++;
        if (EvaluateSituation(XPos,YPos)==2)GenotypeOccurence[2]++;
        if (EvaluateSituation(XPos,YPos)==3)GenotypeOccurence[3]++;
        if (EvaluateSituation(XPos,YPos)==4)GenotypeOccurence[4]++;
        if (EvaluateSituation(XPos,YPos)==5)GenotypeOccurence[5]++;
        if (EvaluateSituation(XPos,YPos)==6)GenotypeOccurence[6]++;
        if (EvaluateSituation(XPos,YPos)==7)GenotypeOccurence[7]++;
        if (EvaluateSituation(XPos,YPos)==8)GenotypeOccurence[8]++;
        if (EvaluateSituation(XPos,YPos)==9)GenotypeOccurence[9]++;
        if (EvaluateSituation(XPos,YPos)==10)GenotypeOccurence[10]++;
        if (EvaluateSituation(XPos,YPos)==11)GenotypeOccurence[11]++;
        if (EvaluateSituation(XPos,YPos)==12)GenotypeOccurence[12]++;
        if (EvaluateSituation(XPos,YPos)==13)GenotypeOccurence[13]++;
        if (EvaluateSituation(XPos,YPos)==14)GenotypeOccurence[14]++;
        if (EvaluateSituation(XPos,YPos)==15)GenotypeOccurence[15]++;
        if (EvaluateSituation(XPos,YPos)==16)GenotypeOccurence[16]++;
        if (EvaluateSituation(XPos,YPos)==17)GenotypeOccurence[17]++;
        if (EvaluateSituation(XPos,YPos)==18)GenotypeOccurence[18]++;
        if (EvaluateSituation(XPos,YPos)==19)GenotypeOccurence[19]++;
        if (EvaluateSituation(XPos,YPos)==20)GenotypeOccurence[20]++;
        if (EvaluateSituation(XPos,YPos)==21)GenotypeOccurence[21]++;
        if (EvaluateSituation(XPos,YPos)==22)GenotypeOccurence[22]++;
        if (EvaluateSituation(XPos,YPos)==23)GenotypeOccurence[23]++;
        if (EvaluateSituation(XPos,YPos)==24)GenotypeOccurence[24]++;
        if (EvaluateSituation(XPos,YPos)==25)GenotypeOccurence[25]++;
        if (EvaluateSituation(XPos,YPos)==26)GenotypeOccurence[26]++;
        if (EvaluateSituation(XPos,YPos)==27)GenotypeOccurence[27]++;
        if (EvaluateSituation(XPos,YPos)==28)GenotypeOccurence[28]++;
        if (EvaluateSituation(XPos,YPos)==29)GenotypeOccurence[29]++;
        if (EvaluateSituation(XPos,YPos)==30)GenotypeOccurence[30]++;
        if (EvaluateSituation(XPos,YPos)==31)GenotypeOccurence[31]++;
        SituationLog[StepCounterAlternate]=EvaluateSituation(XPos,YPos);
        StepCounterAlternate++;
               }

ExplanationMemo->Clear();
if (orientation==1)ExplanationMemo->Lines->Add("Robot je orientovan na sever");
if (orientation==2)ExplanationMemo->Lines->Add("Robot je orientovan na vchod");
if (orientation==3)ExplanationMemo->Lines->Add("Robot je orientovan na juh");
if (orientation==4)ExplanationMemo->Lines->Add("Robot je orientovan na zpad");
ExplanationMemo->Lines->Add("Robot sa nachdza v situcii "+IntToStr(EvaluateSituation(XPos,YPos)) );

if (GetDistanceVector()==1)ExplanationMemo->Lines->Add("Najlepie by bolo dosta sa na sever, vzdialenos by tak klesla na "+FloatToStr(Round2(GetDistance(XPos,YPos+1))) );
if (GetDistanceVector()==2)ExplanationMemo->Lines->Add("Najlepie by bolo dosta sa na vchod, vzdialenos by tak klesla na "+FloatToStr(Round2(GetDistance(XPos+1,YPos))) );
if (GetDistanceVector()==3)ExplanationMemo->Lines->Add("Najlepie by bolo dosta sa na juh, vzdialenos by tak klesla na "+FloatToStr(Round2(GetDistance(XPos,YPos-1))) );
if (GetDistanceVector()==4)ExplanationMemo->Lines->Add("Najlepie by bolo dosta sa na zpad, vzdialenos by tak klesla na "+FloatToStr(Round2(GetDistance(XPos-1,YPos))) );

if (GetDistanceVector()==orientation){NextStepCode=100+SearchKnowledgeBase(EvaluateSituation(XPos,YPos));
                                      ExplanationMemo->Lines->Add("Na zklade bzy znalost sa ukazuje vhodn poui manver ."+IntToStr(NextStepCode)+" - " + TellMeNextMovement(NextStepCode) );}

// Nie je dobra orientacia - to co treba urobit je natocit robota
if (orientation!=GetDistanceVector()){
        ExplanationMemo->Lines->Add("Kee robot nie je orientovan tmto smerom, navrhujem sa otoi do tohto smeru, aby bolo mon poui databzu znalost");
        NextStepCode=GetDistanceVector();       // 1 - otoc sa na sever
                                                // 2 - otoc sa na zapad
                                                // 3 - otoc sa na juh
                                                // 4 - otoc sa na vychod
                                      }}
EndOfSuggestion:

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ExecuteStepButtonClick(TObject *Sender)
{
if (SimulateRadioButton->Checked)ExecuteSimulationStep();
if (RealityRadioButton->Checked){
    ExecuteRealStep();
    ReleaseTimer->Enabled = false;
    ReleaseTimer->Interval = 10000;
    ReleaseTimer->Enabled = true;
          }


}
//---------------------------------------------------------------------------

void __fastcall TForm1::AutoStepTimerTimer(TObject *Sender)
{
if (XPos==XDestination && YPos==YDestination){ShowMessage("Robot dorazil do ciea.");}
  else{
        ExecuteStepButtonClick(Form1);
        if (PrimaryMethod==0)SuggestNextStepRandomButtonClick(Form1);
        if (PrimaryMethod==1)SuggestNextStepGeneticButtonClick(Form1);
        if (PrimaryMethod==2)SuggestNextStepGradientButtonClick(Form1);
        if (PrimaryMethod==3)SuggestNextStepTemporaryButtonClick(Form1);
      }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LoadArrayModelButtonClick(TObject *Sender)
{
 char temp[10];
 FILE * fr;
 FileOpenDialog->Title = "Nahra bludisko";
 FileOpenDialog->DefaultExt = "blu";
 FileOpenDialog->Filter = "Sbory bludiska (*.blu)|*.blu|Vetky sbory (*.*)|*.*";
 FileOpenDialog->FileName = "";
 if (FileOpenDialog->Execute())
  {
   if ((fr = fopen(FileOpenDialog->FileName.c_str(),"r")) == NULL)
    ShowMessage("Nepodarilo sa otvori sbor");
   else
   {
    fscanf(fr,"%s",&temp);             //fake
    fscanf(fr,"%d",&XDestination);     //fake
    fscanf(fr,"%s",&temp);
    fscanf(fr,"%d",&XDestination);
    fscanf(fr,"%s",&temp);
    fscanf(fr,"%d",&YDestination);
      for (int j=0;j<13;j++)
      for (int k=0;k<13;k++)
       fscanf(fr,"%d",&ArrayModel[k][j]);
    fclose(fr);
   }
   InitializeSystem();
  }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::LoadGenotypeButtonClick(TObject *Sender)
{
 FILE *fr;
 char temp[10];
 FileOpenDialog->Title = "Nahra genotyp";
 FileOpenDialog->DefaultExt = "blu";
 FileOpenDialog->Filter = "Sbory populcie (*.pop)|*.pop|Vetky sbory (*.*)|*.*";
 FileOpenDialog->FileName = "";
 if (FileOpenDialog->Execute())
  {
   if ((fr = fopen(FileOpenDialog->FileName.c_str(),"r")) == NULL)
    ShowMessage("Nepodarilo sa otvori sbor");
   else
   {
     for (int j=0;j<32;j++)
       fscanf(fr,"%d",&Genotype[j]);
    fclose(fr);
   }
    InitializeSystem();
  }

}
//---------------------------------------------------------------------------














void __fastcall TForm1::GenotypeGridSelectCell(TObject *Sender, int ACol,
      int ARow, bool &CanSelect)
{
ShowSmallSituation(ACol-1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SaveArrayModelButtonClick(TObject *Sender)
{
 char temp[10];
 FILE * fr;
 FileSaveDialog->Title = "Uloi bludisko";
 FileSaveDialog->DefaultExt = "blu";
 FileSaveDialog->Filter = "Sbory bludiska (*.blu)|*.blu|Vetky sbory (*.*)|*.*";
 FileSaveDialog->FileName = "";
 if (FileSaveDialog->Execute())
  {
   if ((fr = fopen(FileSaveDialog->FileName.c_str(),"w")) == NULL)
    ShowMessage("Nepodarilo sa otvori sbor");
   else
   { fprintf(fr,"bludisk 1\n");
     fprintf(fr,"XCiel %d ",XDestination);
     fprintf(fr,"YCiel %d ",YDestination);

     for (int j=0;j<13;j++){
         fprintf(fr,"\n");
      for (int k=0;k<13;k++){
       fprintf(fr,"%d ",ArrayModel[k][j]);}}
    fclose(fr);
   }
  }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::RecoveryMethod0Click(TObject *Sender)
{
SetRecoveryMethod();
MetricsMethodGroup->Visible=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RecoveryMethod1Click(TObject *Sender)
{
SetRecoveryMethod();
MetricsMethodGroup->Visible=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RecoveryMethod2Click(TObject *Sender)
{
SetRecoveryMethod();
MetricsMethodGroup->Visible=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::InitializeGenotypeButtonClick(TObject *Sender)
{
LoadGenotype();        
}
//---------------------------------------------------------------------------



void __fastcall TForm1::TestArrayModelClick(TObject *Sender)
{
if (CheckLab())ShowMessage("Bludisko m rieenie");
    else ShowMessage("Bludisko nem rieenie");
InitializeSystem();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::RecoveryMethod3Click(TObject *Sender)
{
SetRecoveryMethod();
MetricsMethodGroup->Visible=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RecoveryMethod4Click(TObject *Sender)
{
SetRecoveryMethod();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GenerateGenotypeButtonClick(TObject *Sender)
{
int pom;

                // ISTE - JENDOZNACNE SITUACIE
Genotype[13]=3;   // odozva na situaciu 13 je ISTO L
Genotype[15]=3;   // odozva na situaciu 15 je ISTO L
Genotype[22]=2;   // odozva na situaciu 22 je ISTO R
Genotype[27]=1;   // odozva na situaciu 27 je ISTO F
Genotype[30]=2;   // odozva na situaciu 30 je ISTO R
                // KONIEC ISTYCH - JEDNOZNACNYCH SITUACII



pom=random(3);  // SITUACIE, KDE TREBA CUVNUT
if (pom==0)Genotype[21]=4;
if (pom==1)Genotype[21]=11;
if (pom==2)Genotype[21]=12;
pom=random(3);
if (pom==0)Genotype[23]=4;
if (pom==1)Genotype[23]=11;
if (pom==2)Genotype[23]=12;
pom=random(3);
if (pom==0)Genotype[29]=4;
if (pom==1)Genotype[29]=11;
if (pom==2)Genotype[29]=12;
pom=random(3);
if (pom==0)Genotype[31]=4;
if (pom==1)Genotype[31]=11;
if (pom==2)Genotype[31]=12;
                // KONIEC SITUACII, KDE TREBA CUVNUT


                // SITUACIE, KDE SA TREBA ROZHODNUT - HLAVNE PRVKY GENOMU
pom=random(7);
if (pom==0)Genotype[0]=1;
if (pom==1)Genotype[0]=3;
if (pom==2)Genotype[0]=2;
if (pom==3)Genotype[0]=5;
if (pom==4)Genotype[0]=6;
if (pom==5)Genotype[0]=7;
if (pom==6)Genotype[0]=8;

pom=random(5);
if (pom==0)Genotype[1]=1;
if (pom==1)Genotype[1]=3;
if (pom==2)Genotype[1]=5;
if (pom==3)Genotype[1]=6;
if (pom==4)Genotype[1]=7;

pom=random(5);
if (pom==0)Genotype[2]=1;
if (pom==1)Genotype[2]=2;
if (pom==2)Genotype[2]=3;
if (pom==3)Genotype[2]=5;
if (pom==4)Genotype[2]=7;

pom=random(4);
if (pom==0)Genotype[3]=1;
if (pom==1)Genotype[3]=3;
if (pom==2)Genotype[3]=5;
if (pom==3)Genotype[3]=7;

pom=random(4);
if (pom==0)Genotype[4]=2;
if (pom==1)Genotype[4]=3;
if (pom==2)Genotype[4]=7;
if (pom==3)Genotype[4]=8;

pom=random(2);
if (pom==0)Genotype[5]=3;
if (pom==1)Genotype[5]=7;

pom=random(3);
if (pom==0)Genotype[6]=2;
if (pom==1)Genotype[6]=3;
if (pom==2)Genotype[6]=7;

pom=random(2);
if (pom==0)Genotype[7]=3;
if (pom==1)Genotype[7]=7;

pom=random(5);
if (pom==0)Genotype[8]=1;
if (pom==1)Genotype[8]=2;
if (pom==2)Genotype[8]=3;
if (pom==3)Genotype[8]=6;
if (pom==4)Genotype[8]=8;

pom=random(3);
if (pom==0)Genotype[9]=1;
if (pom==1)Genotype[9]=3;
if (pom==2)Genotype[9]=6;

pom=random(3);
if (pom==0)Genotype[10]=1;
if (pom==1)Genotype[10]=2;
if (pom==2)Genotype[10]=3;

pom=random(2);
if (pom==0)Genotype[11]=1;
if (pom==1)Genotype[11]=3;

pom=random(2);
if (pom==0)Genotype[12]=3;
if (pom==1)Genotype[12]=8;

pom=random(2);
if (pom==0)Genotype[14]=2;
if (pom==1)Genotype[14]=3;

pom=random(4);
if (pom==0)Genotype[16]=1;
if (pom==1)Genotype[16]=2;
if (pom==2)Genotype[16]=5;
if (pom==3)Genotype[16]=6;

pom=random(3);
if (pom==0)Genotype[17]=1;
if (pom==1)Genotype[17]=6;
if (pom==2)Genotype[17]=5;

pom=random(3);
if (pom==0)Genotype[18]=1;
if (pom==1)Genotype[18]=2;
if (pom==2)Genotype[18]=5;

pom=random(2);
if (pom==0)Genotype[19]=1;
if (pom==1)Genotype[19]=5;

pom=random(2);
if (pom==0)Genotype[20]=2;
if (pom==1)Genotype[20]=8;

pom=random(4);
if (pom==0)Genotype[24]=1;
if (pom==1)Genotype[24]=2;
if (pom==2)Genotype[24]=6;
if (pom==3)Genotype[24]=8;

pom=random(2);
if (pom==0)Genotype[25]=1;
if (pom==1)Genotype[25]=6;

pom=random(2);
if (pom==0)Genotype[26]=1;
if (pom==1)Genotype[26]=2;

pom=random(2);
if (pom==0)Genotype[28]=2;
if (pom==1)Genotype[28]=8;

ShowGenotype();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::SuggestNextStepGradientButtonClick(TObject *Sender)
{
if (BlindHolesCheckBox->Checked)FindUselessFields();
if (ZonesCheckBox->Checked)FindUselessZones();


        // Som v cieli
        if (XPos==XDestination && YPos==YDestination){
        StopAutoTimer();
        ExplanationMemo->Clear();
        ExplanationMemo->Lines->Add("Robot sa nachdza v cieli");
        ShowMessage("Robot dorazil do ciea.");
        goto EndOfSuggestion1;}


    if (Array[XPos+1][YPos]>1 && Array[XPos-1][YPos]>1 && Array[XPos][YPos-1]>1 && Array[XPos][YPos+1]>1){StopAutoTimer();ShowMessage("Bludisko nem rieenie");}

ExplanationMemo->Clear();

if (StepCounter>500){StopAutoTimer();
                     ShowMessage("Robot nedorazil do ciea ani po 500 krokoch, algoritmus je pravdepodobne prli slab.");
                     }

if(AutoStepCheckBox->Checked && SimulateRadioButton->Checked){AutoStepTimer->Enabled=true;
                              AutoStepTimer->Interval=5000-AutoStepSpeedTrack->Position;}
   else AutoStepTimer->Enabled=false;

if(AutoStepCheckBox->Checked && RealityRadioButton->Checked){AutoStepTimerReal->Enabled=true;
                              AutoStepTimerReal->Interval=6000-AutoStepSpeedTrack->Position;}
   else AutoStepTimerReal->Enabled=false;



// Step 0 - ak pouzivam metodu docasneho ciela, oznamim to
if (UsingTemporaryTarget && BlindLoop){

                          if (GetDistanceToTemp(XPos,YPos)==1){
                          ExplanationMemo->Lines->Add("Nachdzam sa jeden krok od doasnho ciea, navrhujem vs do doasnho ciea.");
                          if (XPos+1==TempXDestination && YPos==TempYDestination)NextStepCode=12;
                          if (XPos==TempXDestination && YPos+1==TempYDestination)NextStepCode=11;
                          if (XPos-1==TempXDestination && YPos==TempYDestination)NextStepCode=14;
                          if (XPos==TempXDestination && YPos-1==TempYDestination)NextStepCode=13;
                          UsingTemporaryTarget=false;
                          goto EndOfSuggestion1;}
                          

                          ExplanationMemo->Lines->Add("Je zvolen nhradn cie "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination));
                          if (MetricsMethod==1)SetNearestTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==2)SetNearestToDestinationTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==3)SetTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==4)SetRandomTemporaryTarget(XPos,YPos);
                          UsingTemporaryTarget=true;
                          TargetNotReached++;
                          BlindLoop=false;
                            if (TempXDestination!=99 || TempYDestination!=99)ExplanationMemo->Lines->Add("Nastavujem nov doasn cie "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination));
                               else {ExplanationMemo->Lines->Add("Toto bludisko nem rieenie");StopAutoTimer();}
                          NextStepCode=10;
                          goto EndOfSuggestion1;
                                     }


if (UsingTemporaryTarget && !BlindLoop){
        ExplanationMemo->Clear();
        if (TempXDestination==99 && TempYDestination==99){ExplanationMemo->Lines->Add("Toto bludisko nem rieenie");StopAutoTimer();}
            else{

    ExplanationMemo->Lines->Add("Je zvolen nhradn cie "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination));
        if (GetDistanceToTemp(XPos,YPos)==1){
        ExplanationMemo->Lines->Add("Nachdzam sa jeden krok od doasnho ciea, navrhujem vs do doasnho ciea.");
        if (XPos+1==TempXDestination && YPos==TempYDestination)NextStepCode=12;
        if (XPos==TempXDestination && YPos+1==TempYDestination)NextStepCode=11;
        if (XPos-1==TempXDestination && YPos==TempYDestination)NextStepCode=14;
        if (XPos==TempXDestination && YPos-1==TempYDestination)NextStepCode=13;
        //UsingTemporaryTarget=false;
        goto EndOfSuggestion1;}

        if (XPos==TempXDestination && YPos==TempYDestination){
        ExplanationMemo->Clear();
        ExplanationMemo->Lines->Add("Robot dorazil do doasnho ciea.");
        NextStepCode=10;
        UsingTemporaryTarget=false;
        TargetNotReached=0;
        goto EndOfSuggestion1;}


        if (GetDistanceToTemp(XPos,YPos)>1){
        // Navrh dalsieho kroku do docasneho ciela na zaklade gradientu
        NextStepCode=0;                                 // 0 - nebol navrhnuty ziadny dalsi krok
        ShowSmallSituation(EvaluateSituation(XPos,YPos));

        if (orientation==1)ExplanationMemo->Lines->Add("Robot je orientovan na sever");
        if (orientation==2)ExplanationMemo->Lines->Add("Robot je orientovan na vchod");
        if (orientation==3)ExplanationMemo->Lines->Add("Robot je orientovan na juh");
        if (orientation==4)ExplanationMemo->Lines->Add("Robot je orientovan na zpad");
        NextStepCode=SuggestValidMovement(XPos,YPos);
        if (NextStepCode==11)ExplanationMemo->Lines->Add("Navrhujem s na sever, takto sa priblim k cieu najviac ako je to mon.");
        if (NextStepCode==12)ExplanationMemo->Lines->Add("Navrhujem s na vchod, takto sa priblim k cieu najviac ako je to mon.");
        if (NextStepCode==13)ExplanationMemo->Lines->Add("Navrhujem s na juh, takto sa priblim k cieu najviac ako je to mon..");
        if (NextStepCode==14)ExplanationMemo->Lines->Add("Navrhujem s na zpad, takto sa priblim k cieu najviac ako je to mon..");
        goto EndOfSuggestion1;
                                          }

                        } //else konci (bludisko malo riesenie
                        } //if konci (pouzival som docasny ciel a nebol som zacykleny)



// Step 1 - ak som jeden krok od ciela, nic neriesim a proste vojdem do ciela
if (GetDistance(XPos,YPos)==1){
        ExplanationMemo->Lines->Add("Nachdzam sa jeden krok od ciea, navrhujem vs do ciea.");
        if (XPos+1==XDestination && YPos==YDestination)NextStepCode=12;
        if (XPos==XDestination && YPos+1==YDestination)NextStepCode=11;
        if (XPos-1==XDestination && YPos==YDestination)NextStepCode=14;
        if (XPos==XDestination && YPos-1==YDestination)NextStepCode=13;
        goto EndOfSuggestion1;}

// Doslo k zacykleniu je nutne navrhnut nejake rozumne riesenie
if (BlindLoop){ExplanationMemo->Lines->Add("Dolo k zacykleniu.");
               if (RecoveryMethod==0){StopAutoTimer();ShowMessage("Nebola zvolen metda zotavenia sa zo zacyklenia, algoritmus kon nespene.");}
               if (RecoveryMethod==1){RecoveryMethod=3;ExplanationMemo->Lines->Add("Nemono poui metdu Rotcie gnov, automaticky volm metdu doasnho ciea.");RecoveryMethod3->Checked=true;}
               if (RecoveryMethod==2){RecoveryMethod=3;RecoveryMethod=3;ExplanationMemo->Lines->Add("Nemono poui metdu Rotcie gnov, automaticky volm metdu doasnho ciea.");RecoveryMethod3->Checked=true;}
               if (RecoveryMethod==3 || RecoveryMethod==2 || RecoveryMethod==1){
                          if (MetricsMethod==1)SetNearestTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==2)SetNearestToDestinationTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==3)SetTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==4)SetRandomTemporaryTarget(XPos,YPos);
                       UsingTemporaryTarget=true;
                       BlindLoop=false;
                       if (TempXDestination!=99 || TempYDestination!=99)ExplanationMemo->Lines->Add("Nastavujem nov doasn cie "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination));
                          else {ExplanationMemo->Lines->Add("Toto bludisko nem rieenie");StopAutoTimer();}
                       NextStepCode=10;
                                     }

               goto EndOfSuggestion1; }

if (GetDistance(XPos,YPos)>1 && !UsingTemporaryTarget){
// Navrh dalsieho kroku na zaklade gradientu
NextStepCode=0;                                 // 0 - nebol navrhnuty ziadny dalsi krok
ShowSmallSituation(EvaluateSituation(XPos,YPos));

ExplanationMemo->Clear();
if (orientation==1)ExplanationMemo->Lines->Add("Robot je orientovan na sever");
if (orientation==2)ExplanationMemo->Lines->Add("Robot je orientovan na vchod");
if (orientation==3)ExplanationMemo->Lines->Add("Robot je orientovan na juh");
if (orientation==4)ExplanationMemo->Lines->Add("Robot je orientovan na zpad");
NextStepCode=SuggestValidMovement(XPos,YPos);
        if (NextStepCode==11)ExplanationMemo->Lines->Add("Navrhujem s na sever, takto sa priblim k cieu najviac ako je to mon.");
        if (NextStepCode==12)ExplanationMemo->Lines->Add("Navrhujem s na vchod, takto sa priblim k cieu najviac ako je to mon.");
        if (NextStepCode==13)ExplanationMemo->Lines->Add("Navrhujem s na juh, takto sa priblim k cieu najviac ako je to mon..");
        if (NextStepCode==14)ExplanationMemo->Lines->Add("Navrhujem s na zpad, takto sa priblim k cieu najviac ako je to mon..");
                                      }



EndOfSuggestion1:
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PrimaryMethod1Click(TObject *Sender)
{
SetPrimaryMethod();
RecoveryGroup->Visible=true;
RecoveryMethod1->Visible=true;
RecoveryMethod2->Visible=true;
MetricsMethodGroup->Visible=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PrimaryMethod2Click(TObject *Sender)
{
SetPrimaryMethod();
RecoveryGroup->Visible=true;
MetricsMethodGroup->Visible=true;
RecoveryMethod1->Visible=false;
RecoveryMethod2->Visible=false;
RecoveryMethod3->Checked=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Metrics1Click(TObject *Sender)
{
SetMetricsMethod();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Metrics2Click(TObject *Sender)
{
SetMetricsMethod();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Metrics4Click(TObject *Sender)
{
SetMetricsMethod();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SuggestStepClick(TObject *Sender)
{
RefreshArray();

if (PrimaryMethod==0)SuggestNextStepRandomButtonClick(Form1);
if (PrimaryMethod==1)SuggestNextStepGeneticButtonClick(Form1);
if (PrimaryMethod==2)SuggestNextStepGradientButtonClick(Form1);
if (PrimaryMethod==3)SuggestNextStepTemporaryButtonClick(Form1);       
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Metrics3Click(TObject *Sender)
{
SetMetricsMethod();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PrimaryMethod3Click(TObject *Sender)
{
SetPrimaryMethod();
RecoveryGroup->Visible=false;
MetricsMethodGroup->Visible=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SuggestNextStepTemporaryButtonClick(
      TObject *Sender)
{

if (!StepCounter){        if (MetricsMethod==1)SetNearestTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==2)SetNearestToDestinationTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==3)SetTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==4)SetRandomTemporaryTarget(XPos,YPos);
                          ExplanationMemo->Lines->Add("Je zvolen zkladn nhradn cie "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination));
                   }


if (Array[TempXDestination][TempYDestination]>1){

                          if (MetricsMethod==1)SetNearestTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==2)SetNearestToDestinationTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==3)SetTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==4)SetRandomTemporaryTarget(XPos,YPos);
                          ExplanationMemo->Lines->Add("Nhradn cie bol obsaden, je zvolen zkladn nhradn cie "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination));
                                                 }



UsingTemporaryTarget=true;      // VZDY pouzivam docasny ciel

if (BlindHolesCheckBox->Checked)FindUselessFields();
if (ZonesCheckBox->Checked)FindUselessZones();


        // Som v cieli
        if (XPos==XDestination && YPos==YDestination){
        StopAutoTimer();
        ExplanationMemo->Clear();
        ExplanationMemo->Lines->Add("Robot sa nachdza v cieli");
        ShowMessage("Robot dorazil do ciea.");
        goto EndOfSuggestion2;}

// Step 1 - ak som jeden krok od ciela, nic neriesim a proste vojdem do ciela
if (GetDistance(XPos,YPos)==1){
        ExplanationMemo->Lines->Add("Nachdzam sa jeden krok od ciea, navrhujem vs do ciea.");
        if (XPos+1==XDestination && YPos==YDestination)NextStepCode=12;
        if (XPos==XDestination && YPos+1==YDestination)NextStepCode=11;
        if (XPos-1==XDestination && YPos==YDestination)NextStepCode=14;
        if (XPos==XDestination && YPos-1==YDestination)NextStepCode=13;
        goto EndOfSuggestion2;}



    if (Array[XPos+1][YPos]>1 && Array[XPos-1][YPos]>1 && Array[XPos][YPos-1]>1 && Array[XPos][YPos+1]>1){StopAutoTimer();ShowMessage("Bludisko nem rieenie");}

    ExplanationMemo->Clear();

if (StepCounter>500){StopAutoTimer();ShowMessage("Robot nedorazil do ciea ani po 500 krokoch, algoritmus je pravdepodobne prli slab.");}

if(AutoStepCheckBox->Checked && SimulateRadioButton->Checked){AutoStepTimer->Enabled=true;
                              AutoStepTimer->Interval=5000-AutoStepSpeedTrack->Position;}
   else AutoStepTimer->Enabled=false;

if(AutoStepCheckBox->Checked && RealityRadioButton->Checked){AutoStepTimerReal->Enabled=true;
                              AutoStepTimerReal->Interval=6000-AutoStepSpeedTrack->Position;}
   else AutoStepTimerReal->Enabled=false;


// Ak som v docasnom cieli vsetko je vyborne a nic ma nezaujima

        if (XPos==TempXDestination && YPos==TempYDestination){
        ExplanationMemo->Clear();
        ExplanationMemo->Lines->Add("Robot dorazil do doasnho ciea.");
        TargetNotReached=0;
        NextStepCode=10;
        if (MetricsMethod==1)SetNearestTemporaryTarget(XPos,YPos);
        if (MetricsMethod==2)SetNearestToDestinationTemporaryTarget(XPos,YPos);
        if (MetricsMethod==3)SetTemporaryTarget(XPos,YPos);
        if (MetricsMethod==4)SetRandomTemporaryTarget(XPos,YPos);
        BlindLoop=false;        // ak som v cieli urcite nie som zacykleny...
        ExplanationMemo->Lines->Add("Je zvolen nhradn cie "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination));
        goto EndOfSuggestion2;}




// Ak som zacykleny treba to riesit - co najskor
if (BlindLoop){
                          if (GetDistanceToTemp(XPos,YPos)==1){
                          ExplanationMemo->Lines->Add("Nachdzam sa jeden krok od doasnho ciea, navrhujem vs do doasnho ciea.");
                          if (XPos+1==TempXDestination && YPos==TempYDestination)NextStepCode=12;
                          if (XPos==TempXDestination && YPos+1==TempYDestination)NextStepCode=11;
                          if (XPos-1==TempXDestination && YPos==TempYDestination)NextStepCode=14;
                          if (XPos==TempXDestination && YPos-1==TempYDestination)NextStepCode=13;
                          goto EndOfSuggestion2;}

                          ExplanationMemo->Lines->Add("Je zvolen nhradn cie "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination));
                          if (MetricsMethod==1)SetNearestTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==2)SetNearestToDestinationTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==3)SetTemporaryTarget(XPos,YPos);
                          if (MetricsMethod==4)SetRandomTemporaryTarget(XPos,YPos);
                          ExplanationMemo->Lines->Add("Je zvolen nov nhradn cie "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination));
                          TargetNotReached++;
                          BlindLoop=false;
                            if (TempXDestination!=99 || TempYDestination!=99)ExplanationMemo->Lines->Add("Nastavujem nov doasn cie "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination));
                               else {ExplanationMemo->Lines->Add("Toto bludisko nem rieenie");StopAutoTimer();ShowMessage("Bludisko nem rieenie");}
                          NextStepCode=10;
                          goto EndOfSuggestion2;
                                     }

if (!BlindLoop){
        ExplanationMemo->Clear();
        if (TempXDestination==99 && TempYDestination==99){ExplanationMemo->Lines->Add("Toto bludisko nem rieenie");StopAutoTimer();ShowMessage("Bludisko nem rieenie");}
            else{

        ExplanationMemo->Lines->Add("Je zvolen nhradn cie "+IntToStr(TempXDestination)+","+IntToStr(TempYDestination));

        if (GetDistanceToTemp(XPos,YPos)==1){
        ExplanationMemo->Lines->Add("Nachdzam sa jeden krok od doasnho ciea, navrhujem vs do doasnho ciea.");
        if (XPos+1==TempXDestination && YPos==TempYDestination)NextStepCode=12;
        if (XPos==TempXDestination && YPos+1==TempYDestination)NextStepCode=11;
        if (XPos-1==TempXDestination && YPos==TempYDestination)NextStepCode=14;
        if (XPos==TempXDestination && YPos-1==TempYDestination)NextStepCode=13;
        goto EndOfSuggestion2;}

        if (GetDistanceToTemp(XPos,YPos)>1){
     // Navrh dalsieho kroku do docasneho ciela na zaklade gradientu
        NextStepCode=0;                               // 0 - nebol navrhnuty ziadny dalsi krok
        ShowSmallSituation(EvaluateSituation(XPos,YPos));

        if (orientation==1)ExplanationMemo->Lines->Add("Robot je orientovan na sever");
        if (orientation==2)ExplanationMemo->Lines->Add("Robot je orientovan na vchod");
        if (orientation==3)ExplanationMemo->Lines->Add("Robot je orientovan na juh");
        if (orientation==4)ExplanationMemo->Lines->Add("Robot je orientovan na zpad");
            NextStepCode=SuggestValidMovement(XPos,YPos);
        if (NextStepCode==11)ExplanationMemo->Lines->Add("Navrhujem s na sever, takto sa najviac priblim k doasnmu cieu.");
        if (NextStepCode==12)ExplanationMemo->Lines->Add("Navrhujem s na vchod, takto sa najviac priblim k doasnmu cieu.");
        if (NextStepCode==13)ExplanationMemo->Lines->Add("Navrhujem s na juh, takto sa najviac priblim k doasnmu cieu.");
        if (NextStepCode==14)ExplanationMemo->Lines->Add("Navrhujem s na zpad, takto sa najviac priblim k doasnmu cieu.");
        goto EndOfSuggestion2;
                                          }

                        } //else konci (bludisko malo riesenie)
                        } //if konci (nebol som zacykleny)

EndOfSuggestion2:

}
//---------------------------------------------------------------------------






void __fastcall TForm1::ForwardButtonClick(TObject *Sender)
{
NextStepCode=11;ExecuteStepButtonClick(Form1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RightButtonClick(TObject *Sender)
{
if(XPos==XDestination && YPos==YDestination)ShowMessage("Robot sa nachdza v cieli.");
else
if(Array[XPos+1][YPos]!=2){NextStepCode=12;ExecuteStepButtonClick(Form1);}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DownButtonClick(TObject *Sender)
{
if(XPos==XDestination && YPos==YDestination)ShowMessage("Robot sa nachdza v cieli.");
else
if(Array[XPos][YPos-1]!=2){NextStepCode=13;ExecuteStepButtonClick(Form1);}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LeftButtonClick(TObject *Sender)
{
if(XPos==XDestination && YPos==YDestination)ShowMessage("Robot sa nachdza v cieli.");
else
if(Array[XPos-1][YPos]!=2){NextStepCode=14;ExecuteStepButtonClick(Form1);}

}
//---------------------------------------------------------------------------


void __fastcall TForm1::HideModelButtonClick(TObject *Sender)
{
if (ArrayModelImage->Visible){
        ArrayModelImage->Visible=false;
        HideModelButton->Caption="Zobraz model";
        toggleitem->Caption="Zobraz model";
        GenotypeGrid->Visible=false;
        LogListView->Visible=false;
        SuggestStep->Visible=false;
        ExplanationMemo->Visible=false;
        ExecuteStepButton->Visible=false;
        AutoStepCheckBox->Visible=false;
        AutoStepSpeedTrack->Visible=false;
        SpeedInfoLabel->Visible=false;
        InitializeGenotypeButton->Visible=false;
        LoadGenotypeButton->Visible=false;
        GenerateGenotypeButton->Visible=false;
        PrimaryMethodGroup->Visible=false;
        RecoveryGroup->Visible=false;
        MetricsMethodGroup->Visible=false;
        GenotypeModifyInfoLabel->Visible=false;
        ModifyAmmountLabel->Visible=false;
        BlindHolesCheckBox->Checked=false;
        ZonesCheckBox->Checked=false;

        UpButton->Visible=true;
        RightButton->Visible=true;
        DownButton->Visible=true;
        LeftButton->Visible=true;
                               }
else                          {
        ArrayModelImage->Visible=true;
        HideModelButton->Caption="Skry model";
        toggleitem->Caption="Skry model (testovanie lovekom)";        
        GenotypeGrid->Visible=true;
        LogListView->Visible=true;
        SuggestStep->Visible=true;
        ExplanationMemo->Visible=true;
        ExecuteStepButton->Visible=true;
        AutoStepCheckBox->Visible=true;
        AutoStepSpeedTrack->Visible=true;
        SpeedInfoLabel->Visible=true;
        InitializeGenotypeButton->Visible=true;
        LoadGenotypeButton->Visible=true;
        GenerateGenotypeButton->Visible=true;
        PrimaryMethodGroup->Visible=true;
        RecoveryGroup->Visible=true;
        MetricsMethodGroup->Visible=true;
        GenotypeModifyInfoLabel->Visible=true;
        ModifyAmmountLabel->Visible=true;
        BlindHolesCheckBox->Checked=true;
        ZonesCheckBox->Checked=true;

        UpButton->Visible=false;
        RightButton->Visible=false;
        DownButton->Visible=false;
        LeftButton->Visible=false;

                               }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::UpButtonClick(TObject *Sender)
{
if(XPos==XDestination && YPos==YDestination)ShowMessage("Robot sa nachdza v cieli.");
else
if(Array[XPos][YPos+1]!=2){NextStepCode=11;ExecuteStepButtonClick(Form1);}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PrimaryMethod0Click(TObject *Sender)
{
SetPrimaryMethod();
RecoveryGroup->Visible=false;
MetricsMethodGroup->Visible=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SuggestNextStepRandomButtonClick(TObject *Sender)
{
if (BlindHolesCheckBox->Checked)FindUselessFields();
if (ZonesCheckBox->Checked)FindUselessZones();
ExplanationMemo->Clear();

int a;
bool Again=true;

        // Som v cieli
        if (XPos==XDestination && YPos==YDestination){
        StopAutoTimer();
        ExplanationMemo->Clear();
        ExplanationMemo->Lines->Add("Robot sa nachdza v cieli");
        ShowMessage("Robot dorazil do ciea.");
        goto EndOfSuggestion4;}


    if (Array[XPos+1][YPos]>1 && Array[XPos-1][YPos]>1 && Array[XPos][YPos-1]>1 && Array[XPos][YPos+1]>1){StopAutoTimer();ShowMessage("Bludisko nem rieenie");goto EndOfSuggestion4;}

if (StepCounter>500){StopAutoTimer();
                     ShowMessage("Robot nedorazil do ciea ani po 500 krokoch, algoritmus je pravdepodobne prli slab.");
                     }

if(AutoStepCheckBox->Checked && SimulateRadioButton->Checked){AutoStepTimer->Enabled=true;
                              AutoStepTimer->Interval=5000-AutoStepSpeedTrack->Position;}
   else AutoStepTimer->Enabled=false;

if(AutoStepCheckBox->Checked && RealityRadioButton->Checked){AutoStepTimerReal->Enabled=true;
                              AutoStepTimerReal->Interval=6000-AutoStepSpeedTrack->Position;}
   else AutoStepTimerReal->Enabled=false;





while(Again){
a=random(4);
a++;



if (a==1 && Array[XPos][YPos+1]<2){NextStepCode=11;Again=false;}
if (a==1 && Array[XPos][YPos+1]>1)Again=true;

if (a==2 && Array[XPos+1][YPos]<2){NextStepCode=12;Again=false;}
if (a==2 && Array[XPos+1][YPos]>1)Again=true;

if (a==3 && Array[XPos][YPos-1]<2){NextStepCode=13;Again=false;}
if (a==3 && Array[XPos][YPos-1]>1)Again=true;

if (a==4 && Array[XPos-1][YPos]<2){NextStepCode=14;Again=false;}
if (a==4 && Array[XPos-1][YPos]>1)Again=true;
              }

if (NextStepCode==11)ExplanationMemo->Lines->Add("Navrhujem s na sever");
if (NextStepCode==12)ExplanationMemo->Lines->Add("Navrhujem s na vchod");
if (NextStepCode==13)ExplanationMemo->Lines->Add("Navrhujem s na juh");
if (NextStepCode==14)ExplanationMemo->Lines->Add("Navrhujem s na zpad");

EndOfSuggestion4:
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SaveAsImageButtonClick(TObject *Sender)
{
ArrayModelImage->Picture->SaveToFile("bludisko.bmp");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Inicializcia1Click(TObject *Sender)
{
InitializeButtonClick(Form1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Koniec1Click(TObject *Sender)
{
Form1->Close();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Nahrajbludisko1Click(TObject *Sender)
{
LoadArrayModelButtonClick(Form1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Ulobludisko1Click(TObject *Sender)
{
SaveArrayModelButtonClick(Form1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Ulobludiskoakoobrzok1Click(TObject *Sender)
{
SaveAsImageButtonClick(Form1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Otestujbludisko1Click(TObject *Sender)
{
TestArrayModelClick(Form1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Nahrajgenotyp1Click(TObject *Sender)
{
LoadGenotypeButtonClick(Form1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Inicializujgenotyp1Click(TObject *Sender)
{
InitializeGenotypeButtonClick(Form1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Generujnhodngenotyp1Click(TObject *Sender)
{
GenerateGenotypeButtonClick(Form1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Nhodnpohybopilec1Click(TObject *Sender)
{
PrimaryMethod0Click(Form1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Znalostitypugenotyp1Click(TObject *Sender)
{
PrimaryMethod1Click(Form1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Pohybvsmeregradientu1Click(TObject *Sender)
{
PrimaryMethod2Click(Form1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Vobadoasnchcieov1Click(TObject *Sender)
{
PrimaryMethod3Click(Form1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Nepouva1Click(TObject *Sender)
{
RecoveryMethod0Click(Form1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Rotciagnov1Click(TObject *Sender)
{
RecoveryMethod1Click(Form1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Nhodnmodifikciagnov1Click(TObject *Sender)
{
RecoveryMethod2Click(Form1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Vobadoasnhociea1Click(TObject *Sender)
{
RecoveryMethod3Click(Form1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Vzdialenoskrobotovi1Click(TObject *Sender)
{
Metrics1Click(Form1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Vzdialenoskcieu1Click(TObject *Sender)
{
Metrics2Click(Form1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Sumavzdialenostkrobotoviakcieu1Click(
      TObject *Sender)
{
Metrics3Click(Form1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Nhodnebezmetriky1Click(TObject *Sender)
{
Metrics4Click(Form1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Oprograme1Click(TObject *Sender)
{
AboutBox->Show();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::toggleitemClick(TObject *Sender)
{
HideModelButtonClick(Form1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ProgressGraphImageClick(TObject *Sender)
{
ProgressGraphImage->Picture->SaveToFile("graf.bmp");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Ovldanie1Click(TObject *Sender)
{
Application->HelpFile = ExtractFilePath(Application->ExeName) + "sergejmk4.hlp";
Application->HelpCommand(HELP_CONTENTS, 0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComPort1RxChar(TObject *Sender, int Count)
{
  if (RealityRadioButton->Checked == true){
  AnsiString Str;

  ComPort1->ReadStr(Str, Count);
  // ListBox2->Items->Add("Prijal som znak " + Str);
  // ListBox2->Items->Add("NextStepCode bolo " + IntToStr(NextStepCode));

   int temp_orientation = orientation;
   //RealTimer->Enabled=false;
   //RealTimer->Interval = 5000-AutoStepSpeedTrack->Position;

  if (NextStepCode == 11)
   {
    if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 1;NextStepCode=0;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 3;NextStepCode=0;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
   }

  if (NextStepCode == 12)
   {
    if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 2;NextStepCode=0;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 4;NextStepCode=0;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
   }

  if (NextStepCode == 13)
   {
    if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 3;NextStepCode=0;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 1;NextStepCode=0;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
   }

  if (NextStepCode == 14)
   {
    if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 4;NextStepCode=0;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 2;NextStepCode=0;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
    if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
   }

  if (NextStepCode == 101)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 1;NextStepCode=0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 2;NextStepCode=0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 3;NextStepCode=0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 4;NextStepCode=0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    }



   if (NextStepCode == 102)
    {
     if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 2;NextStepCode=0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 3;NextStepCode=0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 4;NextStepCode=0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 1;NextStepCode=0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    }


   if (NextStepCode == 103)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 4;NextStepCode=0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 1;NextStepCode=0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 2;NextStepCode=0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 3;NextStepCode=0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    }

   if (NextStepCode == 104)
    {
     if (orientation == 1)
      {
       if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 1;NextStepCode=0;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 1; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      }
     if (orientation == 2)
      {
       if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 2;NextStepCode=0;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 2; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      }
     if (orientation == 3)
      {
       if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 3;NextStepCode=0;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 3; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      }
     if (orientation == 4)
      {
       if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 4;NextStepCode=0;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 4; NextStepCode = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      }
    }

  if (NextStepCode == 105 && Step == 2)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 4;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 1;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 2;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 3;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    }

  if (NextStepCode == 105 && Step == 1)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 1;Step = 2; ComPort1->WriteStr('g');}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 2;Step = 2; ComPort1->WriteStr('g');}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 3;Step = 2; ComPort1->WriteStr('g');}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 3; NextStepCode = 0;Step = 0;}RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 3; NextStepCode = 0;Step = 0;}RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 3; NextStepCode = 0;Step = 0;}RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 4;Step = 2; ComPort1->WriteStr('g');}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    }

  if (NextStepCode == 106 && Step == 2)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 2;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 3;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 4;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 1;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    }

   if (NextStepCode == 106 && Step == 1)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 1;Step = 2; ComPort1->WriteStr('h');}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 2;Step = 2; ComPort1->WriteStr('h');}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 3;Step = 2; ComPort1->WriteStr('h');}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 4;Step = 2; ComPort1->WriteStr('h');}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    }

  if (NextStepCode == 107 && Step == 2)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 2;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 3;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 4;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 1;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    }

  if (NextStepCode == 107 && Step == 1)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 4;ComPort1->WriteStr('h');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 1;ComPort1->WriteStr('h');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 2;ComPort1->WriteStr('h');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 3;ComPort1->WriteStr('h');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
   }

  if (NextStepCode == 108 && Step == 2)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 4;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 1;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 2;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 3;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    }


  if (NextStepCode == 108 && Step == 1)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 2;ComPort1->WriteStr('g');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 3;ComPort1->WriteStr('g');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 4;ComPort1->WriteStr('g');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 1;ComPort1->WriteStr('g');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
   }

  if (NextStepCode == 109 && Step == 2)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 4;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 1;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 2;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 3;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    }

  if (NextStepCode == 109 && Step == 1)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 4;ComPort1->WriteStr('g');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 1;ComPort1->WriteStr('g');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 2;ComPort1->WriteStr('g');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 3;ComPort1->WriteStr('g');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
   }

   if (NextStepCode == 110 && Step == 2)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 2;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 3;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 4;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 1;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    }


  if (NextStepCode == 110 && Step == 1)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 2;ComPort1->WriteStr('h');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 3;ComPort1->WriteStr('h');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 4;ComPort1->WriteStr('h');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 1;ComPort1->WriteStr('h');Step = 2;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
   }

  if (NextStepCode == 111 && Step == 2)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 4;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 1;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 2;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 3;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    }


   if (NextStepCode == 111 && Step == 1)
    {
     if (orientation == 1)
      {
       if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 1;ComPort1->WriteStr('g');Step = 2;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      }
     if (orientation == 2)
      {
       if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 2;ComPort1->WriteStr('g');Step = 2;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      }
     if (orientation == 3)
      {
       if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 3;ComPort1->WriteStr('g');Step = 2;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      }
     if (orientation == 4)
      {
       if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 4;ComPort1->WriteStr('g');Step = 2;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      }
    }

   if (NextStepCode == 112 && Step == 2)
   {
    if (orientation == 1)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 2;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; temp_orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 2)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 3;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; temp_orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 3)
     {
      if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 4;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; temp_orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    if (orientation == 4)
     {
      if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();temp_orientation = 1;NextStepCode=0;Step = 0;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; temp_orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
     }
    }


   if (NextStepCode == 112 && Step == 1)
    {
     if (orientation == 1)
      {
       if (strcmp(Str.c_str(),"")==0 ) {YPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 1;ComPort1->WriteStr('h');Step = 2;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos-1] = 2; orientation = 1; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      }
     if (orientation == 2)
      {
       if (strcmp(Str.c_str(),"")==0 ) {XPos--; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 2;ComPort1->WriteStr('h');Step = 2;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos-1][YPos] = 2; orientation = 2; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      }
     if (orientation == 3)
      {
       if (strcmp(Str.c_str(),"")==0 ) {YPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 3;ComPort1->WriteStr('h');Step = 2;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos][YPos+1] = 2; orientation = 3; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      }
     if (orientation == 4)
      {
       if (strcmp(Str.c_str(),"")==0 ) {XPos++; Array[XPos][YPos] = 1; ShowRobot();RefreshArray();orientation = 4;ComPort1->WriteStr('h');Step = 2;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
       if (strcmp(Str.c_str(),"")==0 ) {Array[XPos+1][YPos] = 2; orientation = 4; NextStepCode = 0;Step = 0;RealTimer->Interval = 6000-AutoStepSpeedTrack->Position;RealTimer->Enabled = true;}
      }
    }


    if (strcmp(Str.c_str(),"")==0 ) {UpdateLog();}
    if (strcmp(Str.c_str(),"")==0 ) {UpdateLog();}
    if (strcmp(Str.c_str(),"")==0 ) {UpdateLog();}
    if (strcmp(Str.c_str(),"")==0 ) {UpdateLog();}
    if (strcmp(Str.c_str(),"")==0 ) {UpdateLog();}
    if (strcmp(Str.c_str(),"")==0 ) {UpdateLog();}
    if (strcmp(Str.c_str(),"")==0 ) {UpdateLog();}
    if (strcmp(Str.c_str(),"")==0 ) {UpdateLog();}




     orientation = temp_orientation;

     RefreshArray();
     ShowRobot();
     ShowSmallSituation(EvaluateSituation(XPos,YPos));

Form1->ExplanationMemo->Clear();
Form1->ExplanationMemo->Lines->Add("Navrhovan krok bol vykonan");
NotLogged=true;
                        }

}
//---------------------------------------------------------------------------




void __fastcall TForm1::RealTimerTimer(TObject *Sender)
{
 RealTimer->Enabled = false;

if (AutoStepCheckBox->Checked && RealityRadioButton->Checked){

    AutoStepTimerReal->Enabled = true;


if (XPos==XDestination && YPos==YDestination){ShowMessage("Robot dorazil do ciea.");}
        if (PrimaryMethod==0)SuggestNextStepRandomButtonClick(Form1);
        if (PrimaryMethod==1)SuggestNextStepGeneticButtonClick(Form1);
        if (PrimaryMethod==2)SuggestNextStepGradientButtonClick(Form1);
        if (PrimaryMethod==3)SuggestNextStepTemporaryButtonClick(Form1);


                               }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Popispolokbludiska1Click(TObject *Sender)
{
 Form7->Show();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AutoStepTimerRealTimer(TObject *Sender)
{
     AutoStepTimerReal->Enabled = false;
 if (XPos==XDestination && YPos==YDestination){ShowMessage("Robot dorazil do ciea.");}
  else{
        ExecuteStepButtonClick(Form1);
      }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ReleaseTimerTimer(TObject *Sender)
{
 ComPort1->WriteStr('u');
 ReleaseTimer->Enabled = false;         
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
 ComPort1->Connected = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
   AnsiString aaa = "Port " + ComPort1->Port + " pre pripojenie robota nie je k dispozcii";
 char* aa = aaa.c_str();
 try
  {
   Form1->ComPort1->Open();
   Form1->ComPort1->SetRTS(true);
  }
 catch (Exception &e)
   {
    Application->MessageBox(aa, "Sergej ROBOT", MB_OK + MB_DEFBUTTON1 + MB_ICONERROR);
   }


}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
 XPos = 5;
 YPos = 5;
 orientation = 1;
 ShowRobot();        
}
//---------------------------------------------------------------------------

